#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

#include <math.h>
#include <windows.h>
#include "load_bmp.h"
#include "load_3ds.h"
#include "object.h"
#include "ConfigFile.h"

#define BUFSIZE 512

ConfigFile config("DBVD.cfg");
int resolution = config.read<int>("resolution");
int winPoints = config.read<int>("winPoints");

int width = 1280;
int height = 1024;

int font = (int)GLUT_BITMAP_TIMES_ROMAN_24;
int font3D = (int)GLUT_STROKE_ROMAN;
int k = 0;
int zufall;
int zufall1;
int zufall2;
int frames = 0;
int frameTime = 0;
float frameRate = 0;
int kiTime = 0;
int kiWait1 = 1500;
int kiWait2 = 3000;
int runde = 1;

float trans1 = 0.0;
float trans2 = 0.0;
float transSpeed = 2;
int transLimit = 100;

float zoom = -300.0;
float zoomFactor = 4.0;

float rX = 30.0;
float rY = 0.0;
float rspeed = 4.0;

float xAngle = 360;
float yAngle = 90;
float roomDistance = 3300;
float zDistance = -500;
float zBorder = -50;
float yBorder = 10;
float xLimit = ((float) width)/xAngle;
float yLimit = ((float) height)/yAngle;
float zLimit = ((float) height)/zDistance;

float water[720][2][3];

int x1 = 0;
int y01 = 0;
int z1 = 0;
float x2 = 0.0;
float y2 = 0.0;
float z2 = 0.0;
float hold;

bool lButtonOneTime = false;
bool lButtonDown = false;
bool rButtonDown = false;
bool mButtonDown = false;
bool buildFT = false;
bool build = false;
bool trade = false;
bool next = false;
bool wuerfeln = false;
bool interfaceToggle = false;
bool fastForward = false;
bool win = false;
bool redraw = false;
bool playerCheck = false;
bool tradeDelete = false;
bool tradeCheck = false;
bool tradeModus = false;
bool playersChoice = true;
bool numberShow = true;
bool portSign = true;
bool wire = false;
bool fps = false;
bool light = true;
bool options = false;
bool kiTrade = false;
bool player3too1[5] = {false,false,false,false,false};
bool playerKI[5] = {false,true,false,true,true};
bool buildHouse[5][3] = { {false,false,false},{true,false,true},{true,false,true},{true,false,true},{true,false,true} };

int houseBuild = 0;
int posPointsTop = 0;
int posPoints = 0;
int posPoints1 = 0;
int posPoints2 = 0;
int kiTurn = 0;
int picked = 0;
int playersPicked = 2;
int player = 0;
int tradePlayer = 0;
int tradeItem = 0;
int firstTime = 0;
int tradePicked1 = 0;
int tradePicked2 = 0;
int waveCount = 3000;
int xInterface = width/128;
int yInterface = height/102;

//(feld)
int model[19] = {0};
//(nummer)
int number[19] = {0};
//(feld, haus, spieler)
int dice[12][3] = {0};
//(spieler)
int streets[72] = {0};
//(zahl1,zahl2,zahl3,feld1,feld2,feld3,haus,spieler)
int houses[54][8] = {0};
//(punkte,holz,schaf,korn,erz,lehm)
int resources[5][6] = {0};
int tradeArray[5][2] = {0};
//(Holz,Schaf,Korn,Erz,Lehm)
int tradeStep[5];
char s[30];
char interfaceX[20];

GLuint sky[7];
GLfloat sizeTex = 2000;
float skyCorection = 8;

GLfloat light_ambient[]= { 0.75f, 0.75f, 0.75f, 0.75f };
GLfloat light_diffuse[]= { 1.0f, 1.0f, 1.0f, 0.0f };
GLfloat light_specular[]= { 1.0f, 1.0f, 1.0f, 0.0f };
GLfloat light_position[]= { -200.0f, -400.0f, 300.0f, 1.0f };

GLfloat mat_ambient[]= { 0.5f, 0.5f, 0.5f, 0.0f };
GLfloat mat_diffuse[]= { 0.2f, 0.2f, 0.2f, 0.0f };
GLfloat mat_specular[]= { 1.0f, 1.0f, 1.0f, 0.0f };
GLfloat mat_shininess[]= { 1.0f };

obj_type modelV[29];
obj_type housesV[54];
obj_type streetsV[72];
obj_type portV[9];
obj_type pointerV[20];
obj_type interfaceV[72];
obj_type diceV[6];
obj_type playerV[4];
obj_type buildV[5][3];
obj_type tradeV[7];

obj_type deleteObj;

obj_type objectF0;
obj_type objectF1;
obj_type objectF2;
obj_type objectF3;
obj_type objectF4;
obj_type objectF5;
obj_type objectF6;
obj_type objectF7;

obj_type object1;
obj_type object2;
obj_type object3;
obj_type object4;
obj_type object5;
obj_type object6;
obj_type object7;
obj_type object8;
obj_type object9;
obj_type object10;
obj_type object11;
obj_type object12;

obj_type objectB1;
obj_type objectB2;
obj_type objectB3;
obj_type objectB4;
obj_type objectB5;
obj_type objectB6;
obj_type objectB7;
obj_type objectB8;
obj_type objectB9;
obj_type objectB10;
obj_type objectB11;
obj_type objectB12;

obj_type interface0 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -2.5,0.2,0,
            2.5,0.2,0,
            2.5,-0.2,0,
            -2.5,-0.2,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        12,
    };
obj_type interface1 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.1,0.1,0,
            0.1,0.1,0,
            0.1,-0.1,0,
            -0.1,-0.1,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0, 
        },
        13,
    };
obj_type interface2 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.5,0.5,0,
            0.5,0.5,0,
            0.5,-0.5,0,
            -0.5,-0.5,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,   
        },
        14,
    };
obj_type interface3 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.15,0.15,0,
            0.15,0.15,0,
            0.15,-0.15,0,
            -0.15,-0.15,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        15,
    };
obj_type interface4 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.22,0.1,0,
            0.22,0.1,0,
            0.22,-0.1,0,
            -0.22,-0.1,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        16,
    };
obj_type interface5 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.75,1.1,0,
            0.75,1.1,0,
            0.75,-1.1,0,
            -0.75,-1.1,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        17,
    };
obj_type interface6 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.07,0.07,0,
            0.07,0.07,0,
            0.07,-0.07,0,
            -0.07,-0.07,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        18,
    };
obj_type interface7 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.03,0.03,0,
            0.03,0.03,0,
            0.03,-0.03,0,
            -0.03,-0.03,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        19,
    };
obj_type interface8 = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.6,0.75,0,
            0.6,0.75,0,
            0.6,-0.75,0,
            -0.6,-0.75,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        20,
    };
obj_type interfaceW = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -5.0,5.0,0,
            5.0,5.0,0,
            5.0,-5.0,0,
            -5.0,-5.0,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        21,
    };
obj_type interfaceP = 
    {   
        3,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        1,                              
        {
            -2.5,5.0,0.0,
            2.5,5.0,0.0,
            0.0,0.0,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            2, 1, 0
        },
        {
            -5.0,5.0,0,
            5.0,5.0,0,
            0.0,-5.0,0,                
        },
        22,
    };
obj_type interfaceOpB = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.22,0.08,0,
            0.22,0.08,0,
            0.22,-0.08,0,
            -0.22,-0.08,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        23,
    };
obj_type interfaceOp = 
    {   
        4,         
        interfaceX[0],
        interfaceX[1],
        interfaceX[2],
        interfaceX[3],
        interfaceX[4],
        interfaceX[5],
        interfaceX[6],
        interfaceX[7],
        interfaceX[8],
        interfaceX[9],
        interfaceX[10],
        interfaceX[11],
        interfaceX[12],
        interfaceX[13],
        interfaceX[14],
        interfaceX[15],
        interfaceX[16],
        interfaceX[17],
        interfaceX[18],
        interfaceX[19],
        2,                              
        {
            -0.3,0.7,0,
            0.3,0.7,0,
            0.3,-0.7,0,
            -0.3,-0.7,0,
        },
        {
            0,0,0,
            0,0,0,
            0,0,0,
            0,0,0,
        },
        {        
            3, 2, 0,
            2, 1, 0
        },
        {
            0.0, 1.0,
            1.0, 1.0,
            1.0, 0.0,
            0.0, 0.0,
        },
        24,
    };

//(ziel position,strasse1,strasse2,strasse3)
int buildCheck[54][18][4] = { { {2,1,2,-1},{9,0,12,-1},{7,0,11,-1},{3,1,2,4},{10,0,12,14},{10,1,2,3},{19,0,12,13},{17,0,11,10},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {3,2,4,-1},{10,2,3,-1},{8,1,0,-1},{4,2,4,5},{11,2,3,15},{9,2,3,14},{9,1,0,12},{7,1,0,11},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {4,4,5,-1},{11,3,15,-1},{9,3,14,-1},{0,2,1,-1},{5,4,5,7},{12,3,15,17},{12,4,5,6},{21,3,15,16},{19,3,14,13},{8,3,14,12},{8,2,1,0},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {5,5,7,-1},{12,5,6,-1},{10,4,3,-1},{1,4,2,-1},{6,5,7,8},{13,5,6,18},{11,5,6,17},{11,4,3,15},{9,4,3,14},{0,4,2,1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {6,7,8,-1},{13,6,18,-1},{11,6,17,-1},{2,5,4,-1},{14,6,18,20},{14,7,8,9},{23,6,18,19},{21,6,17,16},{10,6,17,15},{10,5,4,3},{1,5,4,2},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {14,8,9,-1},{12,7,6,-1},{3,7,5,-1},{15,8,9,21},{13,7,6,18},{13,8,9,20},{11,7,6,17},{2,7,5,4},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {15,9,21,-1},{13,9,20,-1},{4,8,7,-1},{25,9,21,22},{23,9,20,19},{12,9,20,18},{12,8,7,6},{3,8,7,5},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {0,11,0,-1},{9,11,12,-1},{18,10,25,-1},{16,10,24,-1},{1,11,0,1},{10,11,12,14},{19,11,12,13},{19,10,25,27},{29,10,25,26},{27,10,24,23},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {1,0,1,-1},{10,12,14,-1},{19,12,13,-1},{17,11,10,-1},{2,12,14,3},{2,0,1,2},{11,12,14,15},{20,12,13,28},{18,12,13,27},{18,11,10,25},{16,11,10,24},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {2,14,3,-1},{11,14,15,-1},{20,13,28,-1},{18,13,27,-1},{7,12,11,-1},{0,12,0,-1},{1,14,3,2},{1,12,0,1},{3,14,3,4},{12,14,15,17},{21,13,28,30},{21,14,15,16},{31,13,28,29},{29,13,27,26},{17,13,27,25},{17,12,11,10},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {3,3,4,-1},{12,15,17,-1},{21,15,16,-1},{19,14,13,-1},{8,14,12,-1},{1,3,2,-1},{4,15,17,6},{4,3,4,5},{13,15,17,18},{22,15,16,31},{20,15,16,30},{20,14,13,28},{18,14,13,27},{7,14,12,11},{0,14,12,0},{0,3,2,1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {4,17,6,-1},{13,17,18,-1},{22,16,31,-1},{20,16,30,-1},{9,15,14,-1},{2,15,3,-1},{3,17,6,5},{3,15,3,4},{5,17,6,7},{14,17,18,20},{23,17,18,19},{23,16,31,33},{33,16,31,32},{31,16,30,29},{19,16,30,28},{19,15,14,13},{8,15,14,12},{1,15,3,2} },
      { {5,6,7,-1},{14,18,20,-1},{23,18,19,-1},{21,17,16,-1},{10,17,15,-1},{3,6,5,-1},{6,18,20,9},{6,6,7,8},{15,18,20,21},{24,18,19,34},{22,18,19,33},{22,17,16,31},{20,17,16,30},{9,17,15,14},{2,17,15,3},{2,6,5,4},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {6,20,9,-1},{15,20,21,-1},{24,19,34,-1},{22,19,33,-1},{11,18,17,-1},{4,18,6,-1},{5,20,9,8},{5,18,6,7},{25,19,34,36},{25,21,21,22},{35,19,34,35},{33,19,33,32},{21,18,17,16},{21,19,33,31},{10,18,17,15},{3,18,6,5},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {25,21,22,-1},{23,20,19,-1},{12,20,18,-1},{5,9,8,-1},{26,21,22,37},{24,21,22,36},{24,20,19,34},{22,20,19,33},{11,20,18,17},{4,20,18,6},{4,9,8,7},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {26,22,37,-1},{24,22,36,-1},{13,21,20,-1},{6,21,9,-1},{37,22,37,38},{35,22,36,35},{23,22,36,34},{23,21,20,19},{12,21,20,18},{5,21,9,8},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {7,24,10,-1},{18,24,25,-1},{28,23,39,-1},{8,24,10,11},{19,24,25,27},{29,24,25,26},{29,23,39,41},{38,23,39,40},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {8,10,11,-1},{19,25,27,-1},{29,25,26,-1},{27,24,23,-1},{0,10,11,0},{9,25,27,13},{9,10,11,12},{20,25,27,28},{30,25,26,43},{28,25,26,41},{28,24,23,39},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {9,27,13,-1},{20,27,28,-1},{30,26,42,-1},{28,26,41,-1},{16,25,24,-1},{7,25,10,-1},{8,27,13,12},{8,25,10,11},{10,27,13,14},{21,27,28,30},{31,26,42,44},{31,27,28,29},{40,26,42,43},{38,26,41,40},{27,26,41,39},{27,25,24,23},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {10,13,14,-1},{21,28,30,-1},{31,28,29,-1},{29,27,26,-1},{17,27,25,-1},{8,13,12,-1},{2,13,14,3},{11,28,30,16},{11,13,14,15},{22,28,30,31},{32,28,29,45},{30,28,29,44},{30,27,26,42},{28,27,26,41},{16,27,25,24},{7,13,12,11},{7,27,25,10},{0,13,12,0} },
      { {11,30,16,-1},{22,30,31,-1},{32,29,45,-1},{30,29,44,-1},{18,28,27,-1},{9,28,13,-1},{10,30,16,15},{10,28,13,14},{12,30,16,17},{23,30,31,33},{33,30,31,32},{33,29,45,47},{42,29,45,46},{40,29,44,43},{29,29,44,42},{29,28,27,26},{17,28,27,25},{8,28,13,12} },
      { {12,16,17,-1},{23,31,33,-1},{33,31,32,-1},{31,30,29,-1},{19,30,28,-1},{10,16,15,-1},{4,16,17,6},{13,31,33,19},{13,16,17,18},{24,31,33,34},{34,31,32,48},{32,31,32,47},{32,30,29,45},{30,30,29,44},{18,30,28,27},{9,30,28,13},{9,16,15,14},{2,16,15,3} },
      { {13,33,19,-1},{24,33,34,-1},{34,32,48,-1},{32,32,47,-1},{20,31,30,-1},{11,31,16,-1},{12,33,19,18},{12,31,16,17},{14,33,19,20},{25,33,34,36},{35,33,34,35},{35,32,48,50},{44,32,48,49},{42,32,47,46},{31,32,47,45},{31,31,30,29},{19,31,30,28},{10,31,16,15} },
      { {14,19,20,-1},{25,34,36,-1},{35,34,35,-1},{33,33,32,-1},{21,33,31,-1},{12,19,18,-1},{6,19,20,9},{15,34,36,22},{15,19,20,21},{26,34,36,37},{36,34,35,51},{34,34,35,50},{34,33,32,48},{32,33,32,47},{20,33,31,30},{11,33,31,16},{11,19,18,17},{4,19,18,6} },
      { {15,36,22,-1},{26,36,37,-1},{36,35,51,-1},{34,35,50,-1},{22,34,33,-1},{13,34,19,-1},{14,34,19,20},{14,36,22,21},{37,35,51,53},{37,36,37,38},{46,35,51,52},{44,35,50,49},{33,35,50,48},{33,34,33,32},{21,34,33,31},{12,34,19,18},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {37,37,38,-1},{35,36,35,-1},{23,36,34,-1},{14,22,21,-1},{36,36,35,51},{36,37,38,53},{34,36,35,50},{22,36,34,33},{13,36,34,19},{13,22,21,20},{6,22,21,9},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {36,38,53,-1},{24,37,36,-1},{15,37,22,-1},{46,38,53,52},{35,37,36,35},{35,38,53,51},{23,37,36,34},{14,37,22,21},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {17,23,24,-1},{29,39,41,-1},{38,39,40,-1},{7,23,24,10},{18,39,41,26},{18,23,24,25},{30,39,41,42},{39,39,40,54},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {18,41,26,-1},{30,41,42,-1},{39,40,54,-1},{16,39,23,-1},{17,41,26,25},{17,39,23,24},{19,41,26,27},{31,41,42,44},{40,41,42,43},{40,40,54,56},{47,40,54,55},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {19,26,27,-1},{31,42,44,-1},{40,42,43,-1},{38,41,40,-1},{27,41,39,-1},{17,26,25,-1},{9,26,27,13},{20,42,44,29},{20,26,27,28},{32,42,44,45},{41,42,43,57},{39,42,43,56},{39,41,40,54},{16,26,25,24},{16,41,39,23},{7,26,25,10},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {20,44,29,-1},{32,44,45,-1},{41,43,57,-1},{39,43,56,-1},{28,42,41,-1},{18,42,26,-1},{19,42,26,27},{19,44,29,28},{21,44,29,30},{33,44,45,47},{42,43,57,59},{42,44,45,46},{49,43,57,58},{47,43,56,55},{38,43,56,54},{38,42,41,40},{27,42,41,39},{17,42,26,25} },
      { {21,29,30,-1},{33,45,47,-1},{42,45,46,-1},{40,44,43,-1},{29,44,42,-1},{19,29,28,-1},{11,29,30,16},{22,29,30,31},{22,45,47,32},{34,45,47,48},{43,45,46,60},{41,44,43,57},{41,45,46,59},{39,44,43,56},{28,44,42,41},{18,29,28,27},{18,44,42,26},{9,29,28,13} },
      { {22,47,32,-1},{34,47,48,-1},{43,46,60,-1},{41,46,59,-1},{30,45,44,-1},{20,45,29,-1},{21,47,32,31},{21,45,29,30},{23,47,32,33},{35,47,48,50},{44,47,48,49},{44,46,60,62},{51,46,60,61},{49,46,59,58},{40,45,44,43},{40,46,59,57},{29,45,44,42},{19,45,29,28} },
      { {23,32,33,-1},{35,48,50,-1},{44,48,49,-1},{42,47,46,-1},{31,47,45,-1},{21,32,31,-1},{13,32,33,19},{24,48,50,35},{24,32,33,34},{36,48,50,51},{45,48,49,63},{43,47,46,60},{43,48,49,62},{41,47,46,59},{30,47,45,44},{20,47,45,29},{20,32,31,30},{11,32,31,16} },
      { {24,50,35,-1},{36,50,51,-1},{45,49,63,-1},{43,49,62,-1},{32,48,47,-1},{22,48,32,-1},{23,50,35,34},{23,48,32,33},{25,50,35,36},{37,50,51,53},{46,50,51,52},{46,49,63,65},{53,49,63,64},{51,49,62,61},{42,48,47,46},{42,49,62,60},{31,48,47,45},{21,48,32,31} },
      { {25,35,36,-1},{37,51,53,-1},{46,51,52,-1},{44,50,49,-1},{33,50,48,-1},{23,35,34,-1},{15,35,36,22},{26,35,36,37},{26,51,53,38},{45,51,52,65},{45,50,49,63},{43,50,49,62},{32,50,48,47},{22,50,48,32},{22,35,34,33},{13,35,34,19},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {26,53,38,-1},{45,52,65,-1},{34,51,50,-1},{24,51,35,-1},{25,51,35,36},{25,53,38,37},{53,52,65,64},{44,51,50,49},{44,52,65,63},{33,51,50,48},{23,51,35,34},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {46,53,52,-1},{35,53,51,-1},{25,38,37,-1},{45,53,52,65},{34,53,51,50},{24,53,51,35},{24,38,37,36},{15,38,37,22},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {29,40,41,-1},{40,54,56,-1},{47,54,55,-1},{27,40,39,-1},{18,40,41,26},{30,40,41,42},{30,54,56,43},{41,54,56,57},{48,54,55,66},{16,40,39,23},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {30,56,43,-1},{41,56,57,-1},{48,55,66,-1},{28,54,40,-1},{29,56,43,42},{29,54,40,41},{31,56,43,44},{42,56,57,59},{49,56,57,58},{49,55,66,67},{27,54,40,39},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {31,43,44,-1},{42,57,59,-1},{49,57,58,-1},{47,56,55,-1},{38,56,54,-1},{29,43,42,-1},{20,43,44,29},{32,43,44,45},{32,57,59,46},{43,57,59,60},{50,57,58,68},{48,57,58,67},{48,56,55,66},{28,43,42,41},{28,56,54,40},{18,43,42,26},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {32,59,46,-1},{43,59,60,-1},{50,58,68,-1},{48,58,67,-1},{39,57,56,-1},{30,57,43,-1},{31,59,46,45},{31,57,43,44},{33,59,46,47},{44,59,60,62},{51,58,68,69},{51,59,60,61},{47,57,56,55},{47,58,67,66},{38,57,56,54},{29,57,43,42},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {33,46,47,-1},{44,60,62,-1},{51,60,61,-1},{49,59,58,-1},{40,59,57,-1},{31,46,45,-1},{22,46,47,32},{34,46,47,48},{34,60,62,49},{45,60,62,63},{52,60,61,70},{50,59,58,68},{50,60,61,69},{48,59,58,67},{39,59,57,56},{30,46,45,44},{30,59,57,43},{20,46,45,29} },
      { {34,62,49,-1},{45,62,63,-1},{52,61,70,-1},{50,61,69,-1},{41,60,59,-1},{32,60,46,-1},{33,60,46,47},{33,62,49,48},{35,62,49,50},{46,62,63,65},{53,62,63,64},{53,61,70,71},{49,60,59,58},{49,61,69,68},{40,60,59,57},{31,60,46,45},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {35,49,50,-1},{46,63,65,-1},{53,63,64,-1},{51,62,61,-1},{42,62,60,-1},{33,49,48,-1},{24,49,50,35},{36,49,50,51},{36,63,65,52},{52,62,61,70},{52,63,64,71},{50,62,61,69},{41,62,60,59},{32,49,48,47},{32,62,60,46},{22,49,48,32},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {36,65,52,-1},{52,64,71,-1},{43,63,62,-1},{34,63,49,-1},{35,65,52,51},{35,63,49,50},{37,65,52,53},{51,63,62,61},{51,64,71,70},{42,63,62,60},{33,63,49,48},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {37,52,53,-1},{53,65,64,-1},{44,65,63,-1},{35,52,51,-1},{26,52,53,38},{52,65,64,71},{43,65,63,62},{34,52,51,50},{34,65,63,49},{24,52,51,35},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {40,55,56,-1},{49,66,67,-1},{38,55,54,-1},{30,55,56,43},{41,55,56,57},{41,66,67,58},{50,66,67,68},{28,55,54,40},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {41,67,58,-1},{50,67,68,-1},{39,66,55,-1},{40,67,58,57},{40,66,55,56},{42,67,58,59},{51,67,68,69},{38,66,55,54},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {42,58,59,-1},{51,68,69,-1},{47,67,66,-1},{40,58,57,-1},{32,58,59,46},{43,58,59,60},{43,68,69,61},{52,68,69,70},{39,58,57,56},{39,67,66,55},{30,58,57,43},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {43,69,61,-1},{52,69,70,-1},{48,68,67,-1},{41,68,58,-1},{42,68,58,59},{42,69,61,60},{44,69,61,62},{53,69,70,71},{47,68,67,66},{40,68,58,57},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {44,61,62,-1},{53,70,71,-1},{49,69,68,-1},{42,61,60,-1},{34,61,62,49},{45,61,62,63},{45,70,71,64},{48,69,68,67},{41,69,68,58},{41,61,60,59},{32,61,60,46},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {45,71,64,-1},{50,70,69,-1},{43,70,61,-1},{44,70,61,62},{44,71,64,63},{46,71,64,65},{49,70,69,68},{42,70,61,60},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} },
      { {46,64,65,-1},{51,71,70,-1},{44,64,63,-1},{36,64,65,52},{50,71,70,69},{43,64,63,62},{43,71,70,61},{34,64,63,49},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1} } };
//(house1,house2,house3,strasse1,strasse2,strasse3)
int availableCheck1[54][6] = { {1,8,-1,1,0,-1},{2,0,-1,2,1,-1},{3,10,1,4,3,2},{4,2,-1,5,4,-1},{5,12,3,7,6,5},
      {6,4,-1,8,7,-1},{14,5,-1,9,8,-1},{8,17,-1,11,10,-1},{0,9,7,0,12,11},{10,19,8,14,13,12},
      {2,11,9,3,15,14},{12,21,10,17,16,15},{4,13,11,6,18,17},{14,23,12,20,19,18},{6,15,13,9,21,20},
      {25,14,-1,22,21,-1},{17,27,-1,24,23,-1},{7,18,16,10,25,24},{19,29,17,27,26,25},{9,20,18,13,28,27},
      {21,31,19,30,29,28},{11,22,20,16,31,30},{23,33,21,33,32,31},{13,24,22,19,34,33},{25,35,23,36,35,34},
      {15,26,24,22,37,36},{37,25,-1,38,37,-1},{16,28,-1,23,39,-1},{29,38,27,41,40,39},{18,30,28,26,42,41},
      {31,40,29,44,43,42},{20,32,30,29,45,44},{33,42,31,47,46,45},{22,34,32,32,48,47},{35,44,33,50,49,48},
      {24,36,34,35,51,50},{37,46,35,53,52,51},{26,36,-1,38,53,-1},{28,39,-1,40,54,-1},{40,47,38,56,55,54},
      {30,41,39,43,57,56},{42,49,40,59,58,57},{32,43,41,46,60,59},{44,51,42,62,61,60},{34,45,43,49,63,62},
      {46,53,44,65,64,63},{36,45,-1,52,65,-1},{39,48,-1,55,66,-1},{49,47,-1,67,66,-1},{41,50,48,58,68,67},
      {51,49,-1,69,68,-1},{43,52,50,61,70,69},{53,51,-1,71,70,-1},{45,52,-1,64,71,-1} };
//(house1,house2,strasse1,strasse2,strasse3,strasse4)
int availableCheck2[72][6] = { {0,8,-1,1,12,11},{1,0,-1,2,0,-1},{2,1,4,3,1,-1},{2,10,2,4,15,14},{3,2,-1,5,3,2},
      {4,3,7,6,4,-1},{4,12,5,7,18,17},{5,4,-1,8,6,5},{6,5,-1,9,7,-1},{6,14,8,-1,21,20},
      {7,17,-1,11,25,24},{8,7,0,12,10,-1},{9,8,14,13,11,0},{9,19,12,14,28,27},{10,9,3,15,13,12},
      {11,10,17,16,14,3},{11,21,15,17,31,30},{12,11,6,18,16,15},{13,12,20,19,17,6},{13,23,18,20,34,33},
      {14,13,9,21,19,18},{15,14,-1,22,20,9},{15,25,21,-1,37,36},{16,27,-1,24,39,-1},{17,16,10,25,23,-1},
      {18,17,27,26,24,10},{18,29,25,27,42,41},{19,18,13,28,26,25},{20,19,30,29,27,13},{20,31,28,30,45,44},
      {21,20,16,31,29,28},{22,21,33,32,30,16},{22,33,31,33,48,47},{23,22,19,34,32,31},{24,23,36,35,33,19},
      {24,35,34,36,51,50},{25,24,22,37,35,34},{26,25,-1,38,36,22},{26,37,37,-1,-1,53},{28,27,41,40,-1,23},
      {28,38,39,41,54,-1},{29,28,26,42,40,39},{30,29,44,43,41,26},{30,40,42,44,57,56},{31,30,29,45,43,42},
      {32,31,47,46,44,29},{32,42,45,47,60,59},{33,32,32,48,46,45},{34,33,50,49,47,32},{34,44,48,50,63,62},
      {35,34,35,51,49,48},{36,35,53,52,50,35},{36,46,51,53,-1,65},{37,36,38,-1,52,51},{39,38,56,55,-1,40},
      {39,47,54,56,66,-1},{40,39,43,57,55,54},{41,40,59,58,56,43},{41,49,57,59,68,67},{42,41,46,60,58,57},
      {43,42,62,61,59,46},{43,51,60,62,70,69},{44,43,49,63,61,60},{45,44,65,64,62,49},{45,53,63,65,-1,71},
      {46,45,52,-1,64,63},{48,47,67,-1,-1,55},{49,48,58,68,-1,66},{50,49,69,-1,67,58},{51,50,61,70,-1,68},
      {52,51,71,-1,69,61},{53,52,64,-1,-1,70} };
//(x,y,z)
float positionM[29][4] = { {0.0,0.0,0.0,0},{44.9,25.9,0.0,0},{44.9,-25.9,0.0,0},{0.0,-51.9,0.0,0},{-44.9,-25.9,0.0,0},
      {-44.9,25.9,0.0,0},{0.0,51.9,0.0,0},{44.9,77.8,0.0,0},{89.8,51.9,0.0,0},{89.8,0.0,0.0,0},
      {89.8,-51.9,0.0,0},{44.9,-77.8,0.0,0},{0.0,-103.8,0.0,0},{-44.9,-77.8,0.0,0},{-89.8,-51.9,0.0,0},
      {-89.8,0.0,0.0,0},{-89.8,51.9,0.0,0},{-44.9,77.8,0.0,0},{0.0,103.8,0.0,0},{91.8,105.8,0.0,-60},
      {140.7,26.9,0.0,-60},{134.7,-77.8,0.0,-120},{44.9,-132.7,0.0,180},{-44.9,-132.7,0.0,180},{-134.7,-77.8,0.0,120},
      {-138.7,25.9,0.0,60},{-93.8,105.8,0.0,60},{0.0,155.7,0.0,0},{0.0,0.0,-10.0,0} };
//(x,y,z)
float positionH[54][3] = { {-17.0,130.0,0.0},{17.0,130.0,0.0},{28.0,105.0,0.0},{60.0,105.0,0.0},{75.0,78.0,0.0},
      {105.0,78.0,0.0},{120.0,52.0,0.0},{-60.0,105.0,0.0},{-28.0,105.0,0.0},{-17.0,78.0,0.0},
      {17.0,78.0,0.0},{28.0,52.0,0.0},{60.0,52.0,0.0},{73.0,26.0,0.0},{105.0,26.0,0.0},
      {120.0,0.0,0.0},{-105.0,78.0,0.0},{-75.0,78.0,0.0},{-60.0,52.0,0.0},{-28.0,52.0,0.0},
      {-17.0,26.0,0.0},{17.0,26.0,0.0},{28.0,0.0,0.0},{60.0,0.0,0.0},{73.0,-26.0,0.0},
      {105.0,-26.0,0.0},{120.0,-52.0,0.0},{-120.0,52.0,0.0},{-105.0,26.0,0.0},{-73.0,26.0,0.0},
      {-60.0,0.0,0.0},{-28.0,0.0,0.0},{-17.0,-26.0,0.0},{17.0,-26.0,0.0},{28.0,-52.0,0.0},
      {60.0,-52.0,0.0},{73.0,-78.0,0.0},{105.0,-78.0,0.0},{-120.0,0.0,0.0},{-105.0,-26.0,0.0},
      {-73.0,-26.0,0.0},{-60.0,-52.0,0.0},{-28.0,-52.0,0.0},{-17.0,-78.0,0.0},{17.0,-78.0,0.0},
      {28.0,-105.0,0.0},{60.0,-105.0,0.0},{-120.0,-52.0,0.0},{-105.0,-78.0,0.0},{-73.0,-78.0,0.0},
      {-60.0,-105.0,0.0},{-28.0,-105.0,0.0},{-17.0,-130.0,0.0},{17.0,-130.0,0.0} };
//(x,y,z,rotation)
float positionS[72][4] = { {-22.0,117.0,0.0,-30},{0.0,129.0,0.0,-90},{22.0,117.0,0.0,30},{22.0,91.0,0.0,-30},{45.0,104.0,0.0,-90},
      {67.0,91.0,0.0,30},{67.0,65.0,0.0,-30},{90.0,78.0,0.0,-90},{112.0,65.0,0.0,30},{112.0,40.0,0.0,-30},
      {-67.0,90.0,0.0,-30},{-45.0,104.0,0.0,-90},{-22.0,91.0,0.0,30},{-22.0,65.0,0.0,-30},{0.0,78.0,0.0,-90},
      {22.0,65.0,0.0,30},{23.0,40.0,0.0,-30},{45.0,52.0,0.0,-90},{67.0,40.0,0.0,30},{67.0,13.0,0.0,-30},
      {90.0,26.0,0.0,-90},{112.0,13.0,0.0,30},{112.0,-13.0,0.0,-30},{-112.0,65.0,0.0,-30},{-90.0,78.0,0.0,-90},
      {-67.0,65.0,0.0,30},{-67.0,40.0,0.0,-30},{-45.0,52.0,0.0,-90},{-23.0,40.0,0.0,30},{-23.0,13.0,0.0,-30},
      {0.0,26.0,0.0,-90},{23.0,13.0,0.0,30},{23.0,-13.0,0.0,-30},{45.0,0.0,0.0,-90},{67.0,-13.0,0.0,30},
      {67.0,-40.0,0.0,-30},{90.0,-26.0,0.0,-90},{112.0,-40.0,0.0,30},{112.0,-65.0,0.0,-30},{-112.0,40.0,0.0,30},
      {-112.0,13.0,0.0,-30},{-90.0,26.0,0.0,-90},{-67.0,13.0,0.0,30},{-67.0,-13.0,0.0,-30},{-45.0,0.0,0.0,-90},
      {-23.0,-13.0,0.0,30},{-23.0,-40.0,0.0,-30},{0.0,-26.0,0.0,-90},{23.0,-40.0,0.0,30},{22.0,-65.0,0.0,-30},
      {45.0,-52.0,0.0,-90},{67.0,-65.0,0.0,30},{67.0,-91.0,0.0,-30},{90.0,-78.0,0.0,-90},{-112.0,-13.0,0.0,30},
      {-112.0,-40.0,0.0,-30},{-90.0,-26.0,0.0,-90},{-67.0,-40.0,0.0,30},{-67.0,-65.0,0.0,-30},{-45.0,-52.0,0.0,-90},
      {-22.0,-65.0,0.0,30},{-22.0,-91.0,0.0,-30},{0.0,-78.0,0.0,-90},{22.0,-91.0,0.0,30},{22.0,-117.0,0.0,-30},
      {45.0,-104.0,0.0,-90},{-112.0,-65.0,0.0,30},{-90.0,-78.0,0.0,-90},{-67.0,-91.0,0.0,30},{-45.0,-104.0,0.0,-90},
      {-22.0,-117.0,0.0,30},{0.0,-129.0,0.0,-90} };
//(x,y,z)
float positionW[9][3] = { {89.8,103.8,30.0},{134.7,25.9,30.0},{134.7,-77.8,30.0},{44.9,-129.7,30.0},{-44.9,-129.7,30.0},
      {-134.7,-77.8,30.0},{-134.7,25.9,30.0},{-89.8,103.8,30.0},{0.0,155.7,30.0} };
//(x,y,z)
float positionP[20][3] = { {0.0,0.0,30.0},{44.9,25.9,30.0},{44.9,-25.9,30.0},{0.0,-51.9,30.0},{-44.9,-25.9,30.0},
      {-44.9,25.9,30.0},{0.0,51.9,30.0},{44.9,77.8,30.0},{89.8,51.9,30.0},{89.8,0.0,30.0},
      {89.8,-51.9,30.0},{44.9,-77.8,30.0},{0.0,-103.8,30.0},{-44.9,-77.8,30.0},{-89.8,-51.9,30.0},
      {-89.8,0.0,30.0},{-89.8,51.9,30.0},{-44.9,77.8,30.0},{0.0,103.8,30.0},{0.0,0.0,-10.0} };
//(x,y,z)
float positionI[72][3] = { {0.0,-1.8,-4.0},{-1.52,-1.75,-3.9999},{-1.32,-1.75,-3.9999},{-1.12,-1.75,-3.9999},{-0.92,-1.75,-3.9999},
      {-0.72,-1.75,-3.9999},{-1.9,-1.0,-3.9999},{-0.3,-1.8,-3.9999},{0.2,-1.8,-3.9999},{-2.25,-1.74,-3.9999},
      {1.0,-1.8,-3.9999},{1.5,-1.8,-3.9999},{2.2,-1.8,-3.9999},{0.0,0.1,-4.0},{0.0,-0.8,-3.9999},
      {-0.4,0.8,-3.9999},{-0.4,0.5,-3.9999},{-0.4,0.2,-3.9999},{-0.4,-0.1,-3.9999},{-0.4,-0.4,-3.9999},
      {-0.5,0.67,-3.9999},{-0.5,0.37,-3.9999},{-0.5,0.07,-3.9999},{-0.5,-0.22,-3.9999},{-0.5,-0.52,-3.9999},
      {-0.3,0.67,-3.9999},{-0.3,0.37,-3.9999},{-0.3,0.07,-3.9999},{-0.3,-0.22,-3.9999},{-0.3,-0.52,-3.9999},
      {0.4,0.8,-3.9999},{0.4,0.5,-3.9999},{0.4,0.2,-3.9999},{0.4,-0.1,-3.9999},{0.4,-0.4,-3.9999},
      {0.5,0.67,-3.9999},{0.5,0.37,-3.9999},{0.5,0.07,-3.9999},{0.5,-0.22,-3.9999},{0.5,-0.52,-3.9999},
      {0.3,0.67,-3.9999},{0.3,0.37,-3.9999},{0.3,0.07,-3.9999},{0.3,-0.22,-3.9999},{0.3,-0.52,-3.9999},
      {0.0,0.5,-3.9999},{0.0,0.3,-3.9999},{0.0,0.1,-3.9999},{0.0,-0.1,-3.9999},{0.0,-0.3,-3.9999},
      {0.0,0.1,-4.0},{0.0,-0.4,-3.9999},{0.0,0.5,-3.9999},{0.0,0.3,-3.9999},{0.0,0.1,-3.9999},
      {0.0,-0.1,-3.9999},{-0.3,0.5,-3.9999},{-0.3,0.3,-3.9999},{-0.3,0.1,-3.9999},{-0.3,-0.1,-3.9999},
      {0.3,0.5,-3.9999},{0.3,0.3,-3.9999},{0.3,0.1,-3.9999},{0.3,-0.1,-3.9999},{-2.25,-1.9,-3.9999},
      {-2.1,-0.2,-3.9999},{-2.1,0.0,-3.9999},{-2.1,0.2,-3.9999},{-2.1,0.4,-3.9999},{-2.1,0.6,-3.9999},
      {-2.1,0.8,-3.9999},{-2.1,0.3,-4.0} };

static void 
resize(int w, int h)
{
    const float ar = (float) width / (float) height;
    
    glViewport(0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glFrustum(-ar, ar, -1.0, 1.0, 2.0, roomDistance);    
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity() ;
}

void setOrthographicProjection() {
	glMatrixMode(GL_PROJECTION);
	glDisable(GL_TEXTURE_2D);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0, width, 0, height);
	glScalef(1, -1, 1);
	glTranslatef(0, -height, 0);
	glMatrixMode(GL_MODELVIEW);
}

void resetPerspectiveProjection() {
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glEnable(GL_TEXTURE_2D);
	glMatrixMode(GL_MODELVIEW);
}

void renderBitmapString(float x, float y, void *font,char *string)
{  
  char *c;
  glRasterPos2f(x, y);
  for (c=string; *c != '\0'; c++) {
    glutBitmapCharacter(font, *c);
  }
}

void renderStrokeCharacter(float x, float y, float z, void *font3D,char *string)
{  
  char *c;
  glPushMatrix();
  glTranslatef(x, y, z);
  for (c=string; *c != '\0'; c++) {
    glutStrokeCharacter(font3D, *c);
  }  
  glPopMatrix();
}

void init(void)
{
    glClearColor(1,1,1,1);
    
    glLightfv (GL_LIGHT1, GL_AMBIENT, light_ambient);
    glLightfv (GL_LIGHT1, GL_DIFFUSE, light_diffuse);
    glLightfv (GL_LIGHT1, GL_DIFFUSE, light_specular);
    glEnable (GL_LIGHT1);
    glEnable (GL_LIGHTING);

    glMaterialfv (GL_FRONT, GL_AMBIENT, mat_ambient);
    glMaterialfv (GL_FRONT, GL_DIFFUSE, mat_diffuse);
    glMaterialfv (GL_FRONT, GL_DIFFUSE, mat_specular);
    
    glShadeModel(GL_SMOOTH);
    
    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);
    
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity(); 
    
    glEnable(GL_DEPTH_TEST);
    glDepthRange(0.0, 1.0);
    glDepthFunc(GL_LESS);
    
    glEnable(GL_TEXTURE_2D);
    
    for(int x=0; x<720; x++)
	{
		for(int y=0; y<2; y++)
		{
			water[x][y][0]=float((x*5.6f)-4.5f);
			water[x][y][1]=float((y*4020.0f)-4.5f);
			water[x][y][2]=float((sin((((x/10.0f)*80.0f)/360.0f)*3.141592654*2.0f))*1);
		}
	}
    
    Load3DS (&objectF0,"models/strand.3ds");
    objectF0.id_texture=LoadBMP("texturen/sand.bmp");
    ObjCalcNormals(&objectF0);
    Load3DS (&objectF1,"models/wald.3ds");
    objectF1.id_texture=LoadBMP("texturen/wald.bmp");
    ObjCalcNormals(&objectF1);
    Load3DS (&objectF2,"models/schaf.3ds");
    objectF2.id_texture=LoadBMP("texturen/schaf.bmp");
    ObjCalcNormals(&objectF2);
    Load3DS (&objectF3,"models/weizenfeld.3ds");
    objectF3.id_texture=LoadBMP("texturen/weizenfeld.bmp");
    ObjCalcNormals(&objectF3);
    Load3DS (&objectF4,"models/berg.3ds");
    objectF4.id_texture=LoadBMP("texturen/berg.bmp");
    ObjCalcNormals(&objectF4);
    Load3DS (&objectF5,"models/lehm.3ds");
    objectF5.id_texture=LoadBMP("texturen/lehm.bmp");
    ObjCalcNormals(&objectF5);
    Load3DS (&objectF6,"models/wueste.3ds");
    objectF6.id_texture=LoadBMP("texturen/wueste.bmp");
    ObjCalcNormals(&objectF6);
    Load3DS (&objectF7,"models/hafen.3ds");
    objectF7.id_texture=LoadBMP("texturen/hafen.bmp");
    ObjCalcNormals(&objectF7);
    
    Load3DS (&object1,"models/siedlung.3ds");
    object1.id_texture=LoadBMP("texturen/siedlung1.bmp");
    ObjCalcNormals(&object1);    
    Load3DS (&object2,"models/siedlung.3ds");
    object2.id_texture=LoadBMP("texturen/siedlung2.bmp");
    ObjCalcNormals(&object2);
    Load3DS (&object3,"models/siedlung.3ds");
    object3.id_texture=LoadBMP("texturen/siedlung3.bmp");
    ObjCalcNormals(&object3);    
    Load3DS (&object4,"models/siedlung.3ds");
    object4.id_texture=LoadBMP("texturen/siedlung4.bmp");
    ObjCalcNormals(&object4);
    Load3DS (&object5,"models/stadt.3ds");
    object5.id_texture=LoadBMP("texturen/stadt1.bmp");
    ObjCalcNormals(&object5);
    Load3DS (&object6,"models/stadt.3ds");
    object6.id_texture=LoadBMP("texturen/stadt2.bmp");
    ObjCalcNormals(&object6);
    Load3DS (&object7,"models/stadt.3ds");
    object7.id_texture=LoadBMP("texturen/stadt3.bmp");
    ObjCalcNormals(&object7);
    Load3DS (&object8,"models/stadt.3ds");
    object8.id_texture=LoadBMP("texturen/stadt4.bmp");
    ObjCalcNormals(&object8);
    Load3DS (&object9,"models/weg.3ds");
    object9.id_texture=LoadBMP("texturen/weg1.bmp");
    ObjCalcNormals(&object9);
    Load3DS (&object10,"models/weg.3ds");
    object10.id_texture=LoadBMP("texturen/weg2.bmp");
    ObjCalcNormals(&object10);
    Load3DS (&object11,"models/weg.3ds");
    object11.id_texture=LoadBMP("texturen/weg3.bmp");
    ObjCalcNormals(&object11);
    Load3DS (&object12,"models/weg.3ds");
    object12.id_texture=LoadBMP("texturen/weg4.bmp");
    ObjCalcNormals(&object12);
    
    Load3DS (&objectB1,"models/siedlung.3ds");    
    objectB1.id_texture=LoadBMP("texturen/spieler1.bmp");
    ObjCalcNormals(&objectB1);
    buildV[1][1] = objectB1;
    Load3DS (&objectB2,"models/siedlung.3ds");
    objectB2.id_texture=LoadBMP("texturen/spieler2.bmp");
    ObjCalcNormals(&objectB2);
    buildV[2][1] = objectB2;
    Load3DS (&objectB3,"models/siedlung.3ds");
    objectB3.id_texture=LoadBMP("texturen/spieler3.bmp");
    ObjCalcNormals(&objectB3);
    buildV[3][1] = objectB3;    
    Load3DS (&objectB4,"models/siedlung.3ds");
    objectB4.id_texture=LoadBMP("texturen/spieler4.bmp");
    ObjCalcNormals(&objectB4);
    buildV[4][1] = objectB4;
    Load3DS (&objectB5,"models/stadt.3ds");
    objectB5.id_texture=LoadBMP("texturen/spieler1.bmp");
    ObjCalcNormals(&objectB5);
    buildV[1][2] = objectB5;
    Load3DS (&objectB6,"models/stadt.3ds");
    objectB6.id_texture=LoadBMP("texturen/spieler2.bmp");
    ObjCalcNormals(&objectB6);
    buildV[2][2] = objectB6;
    Load3DS (&objectB7,"models/stadt.3ds");
    objectB7.id_texture=LoadBMP("texturen/spieler3.bmp");
    ObjCalcNormals(&objectB7);
    buildV[3][2] = objectB7;
    Load3DS (&objectB8,"models/stadt.3ds");
    objectB8.id_texture=LoadBMP("texturen/spieler4.bmp");
    ObjCalcNormals(&objectB8);
    buildV[4][2] = objectB8;    
    Load3DS (&objectB9,"models/weg.3ds");
    objectB9.id_texture=LoadBMP("texturen/spieler1.bmp");
    ObjCalcNormals(&objectB9);
    buildV[1][0] = objectB9;
    Load3DS (&objectB10,"models/weg.3ds");
    objectB10.id_texture=LoadBMP("texturen/spieler2.bmp");
    ObjCalcNormals(&objectB10);
    buildV[2][0] = objectB10;
    Load3DS (&objectB11,"models/weg.3ds");
    objectB11.id_texture=LoadBMP("texturen/spieler3.bmp");
    ObjCalcNormals(&objectB11);
    buildV[3][0] = objectB11;
    Load3DS (&objectB12,"models/weg.3ds");
    objectB12.id_texture=LoadBMP("texturen/spieler4.bmp");
    ObjCalcNormals(&objectB12);
    buildV[4][0] = objectB12;    
    
    glGenTextures(1, &sky[0]);	
	LoadBMP("texturen/wasser.bmp");
	
    glGenTextures(1, &sky[2]);	
    LoadBMP("texturen/top.bmp");
    glGenTextures(1, &sky[1]);	
    LoadBMP("texturen/bot.bmp");
    glGenTextures(1, &sky[6]);	
    LoadBMP("texturen/side1.bmp");
    glGenTextures(1, &sky[5]);	
    LoadBMP("texturen/side2.bmp");
    glGenTextures(1, &sky[3]);	
    LoadBMP("texturen/side3.bmp");
    glGenTextures(1, &sky[4]);	
    LoadBMP("texturen/side4.bmp");
    
    interfaceW.id_texture=LoadBMP("texturen/karten1.bmp");
    portV[4] = interfaceW;    
    interfaceW.id_texture=LoadBMP("texturen/karten2.bmp");
    portV[0] = interfaceW;    
    interfaceW.id_texture=LoadBMP("texturen/karten3.bmp");
    portV[6] = interfaceW;    
    interfaceW.id_texture=LoadBMP("texturen/karten4.bmp");
    portV[7] = interfaceW;
    interfaceW.id_texture=LoadBMP("texturen/karten5.bmp");
    portV[3] = interfaceW;
    interfaceW.id_texture=LoadBMP("texturen/3zu1.bmp");
    portV[1] = interfaceW;
    portV[2] = interfaceW;
    portV[5] = interfaceW;
    portV[8] = interfaceW;
    
    interface0.id_texture=LoadBMP("texturen/gui.bmp");
    interfaceV[0] = interface0;
    interface1.id_texture=LoadBMP("texturen/karten1.bmp");
    interfaceV[1] = interface1;    
    interface1.id_texture=LoadBMP("texturen/karten2.bmp");
    interfaceV[2] = interface1;    
    interface1.id_texture=LoadBMP("texturen/karten3.bmp");
    interfaceV[3] = interface1;    
    interface1.id_texture=LoadBMP("texturen/karten4.bmp");
    interfaceV[4] = interface1;
    interface1.id_texture=LoadBMP("texturen/karten5.bmp");
    interfaceV[5] = interface1;
    interface6.id_texture=LoadBMP("texturen/karten1.bmp");
    tradeV[0] = interface6;
    interface6.id_texture=LoadBMP("texturen/karten2.bmp");
    tradeV[1] = interface6;
    interface6.id_texture=LoadBMP("texturen/karten3.bmp");
    tradeV[2] = interface6;
    interface6.id_texture=LoadBMP("texturen/karten4.bmp");
    tradeV[3] = interface6;
    interface6.id_texture=LoadBMP("texturen/karten5.bmp");
    tradeV[4] = interface6;
    interface6.id_texture=LoadBMP("texturen/knopf2.bmp");
    interfaceV[52] = interface6;
    interfaceV[53] = interface6;
    interfaceV[54] = interface6;
    interfaceV[55] = interface6;
    interface7.id_texture=LoadBMP("texturen/minus.bmp");
    tradeV[5] = interface7;
    interface7.id_texture=LoadBMP("texturen/plus.bmp");
    tradeV[6] = interface7;
    interface2.id_texture=LoadBMP("texturen/bauen.bmp");
    interface3.id_texture=LoadBMP("texturen/wuerfel1.bmp");
    diceV[0] = interface3;
    interface3.id_texture=LoadBMP("texturen/wuerfel2.bmp");
    diceV[1] = interface3;
    interface3.id_texture=LoadBMP("texturen/wuerfel3.bmp");
    diceV[2] = interface3;
    interface3.id_texture=LoadBMP("texturen/wuerfel4.bmp");
    diceV[3] = interface3;
    interface3.id_texture=LoadBMP("texturen/wuerfel5.bmp");
    diceV[4] = interface3;
    interface3.id_texture=LoadBMP("texturen/wuerfel6.bmp");
    diceV[5] = interface3;
    interface4.id_texture=LoadBMP("texturen/knopf2.bmp");
    interfaceV[10] = interface4;    
    interfaceV[11] = interface4;    
    interfaceV[12] = interface4;
    interfaceV[51] = interface4;
    interfaceV[56] = interface4;
    interfaceV[57] = interface4;
    interfaceV[58] = interface4;
    interfaceV[59] = interface4;
    interfaceV[60] = interface4;
    interfaceV[61] = interface4;
    interfaceV[62] = interface4;
    interfaceV[63] = interface4;
    interfaceOpB.id_texture=LoadBMP("texturen/knopf2.bmp");
    interfaceV[9] = interfaceOpB;
    interfaceV[64] = interfaceOpB;
    interface5.id_texture=LoadBMP("texturen/handelgui.bmp");
    interfaceOp.id_texture=LoadBMP("texturen/waehlgui.bmp");
    interface8.id_texture=LoadBMP("texturen/handelgui.bmp");
    interfaceV[50] = interface8;
    interface3.id_texture=LoadBMP("texturen/weiss.bmp");
    pointerV[19] = interface3;
    interface3.id_texture=LoadBMP("texturen/spieler1.bmp");
    playerV[0] = interface3;
    interface3.id_texture=LoadBMP("texturen/spieler2.bmp");
    playerV[1] = interface3;
    interface3.id_texture=LoadBMP("texturen/spieler3.bmp");
    playerV[2] = interface3;
    interface3.id_texture=LoadBMP("texturen/spieler4.bmp");
    playerV[3] = interface3;
    interfaceP.id_texture=LoadBMP("texturen/spieler1.bmp");
    
    if (winPoints < 4) {
       winPoints = 4;
    } else if (winPoints > 12) {
       winPoints = 12;
    }
}

static void 
draw(GLenum mode)
{
  if(mode == GL_SELECT)  {
    glInitNames();
    glPushName(0);
  }
    
    int l_index;
    float float_x, float_y, float_xb, float_yb;
    
    glPushMatrix();
    glTranslatef(trans1,trans2,zoom);
    glRotatef(rX,1.0,0.0,0.0);
    glRotatef(rY,0.0,1.0,0.0);
    glRotatef(-90,1.0,0.0,0.0);
    glRotatef(30,0.0,0.0,1.0);
    
    if (light == true) {
        glLightfv (GL_LIGHT1, GL_POSITION, light_position);
        glMaterialfv (GL_FRONT, GL_POSITION, mat_shininess);
        glDisable (GL_LIGHTING);    
    }
    /*glTranslatef(light_position[0],light_position[1],light_position[2]);
    glutSolidSphere(10,16,16);
    glTranslatef(-light_position[0],-light_position[1],-light_position[2]);*/
    
        glBindTexture(GL_TEXTURE_2D, sky[3]);
		glBegin(GL_QUADS);
			//glNormal3f(1,0,0);
            glTexCoord2f(0.0f, 0.0f);
			glVertex3f(-sizeTex+skyCorection, -sizeTex, -sizeTex);
			//glNormal3f(1,0,0);
            glTexCoord2f(1.0f, 0.0f);
			glVertex3f(-sizeTex+skyCorection, sizeTex, -sizeTex);
			//glNormal3f(1,0,0);
            glTexCoord2f(1.0f, 1.0f);
			glVertex3f(-sizeTex+skyCorection, sizeTex, sizeTex);
			//glNormal3f(1,0,0);
            glTexCoord2f(0.0f, 1.0f);
			glVertex3f(-sizeTex+skyCorection, -sizeTex, sizeTex);
		glEnd();
	    
		glBindTexture(GL_TEXTURE_2D, sky[1]);
		glBegin(GL_QUADS);
			//glNormal3f(0,0,1);
            glTexCoord2f(1.0f, 0.0f);
			glVertex3f(-sizeTex, sizeTex, -sizeTex+skyCorection);
			//glNormal3f(0,0,1);
            glTexCoord2f(1.0f, 1.0f);
			glVertex3f(-sizeTex, -sizeTex, -sizeTex+skyCorection);
			//glNormal3f(0,0,1);
            glTexCoord2f(0.0f, 1.0f);
			glVertex3f(sizeTex, -sizeTex, -sizeTex+skyCorection);
			//glNormal3f(0,0,1);
            glTexCoord2f(0.0f, 0.0f);
			glVertex3f(sizeTex, sizeTex, -sizeTex+skyCorection);
		glEnd();
	    
		glBindTexture(GL_TEXTURE_2D, sky[4]);
		glBegin(GL_QUADS);
			//glNormal3f(0,-1,0);
            glTexCoord2f(1.0f, 0.0f);
			glVertex3f(sizeTex, sizeTex-skyCorection, -sizeTex);
			//glNormal3f(0,-1,0);
            glTexCoord2f(1.0f, 1.0f);
			glVertex3f(sizeTex, sizeTex-skyCorection, sizeTex);
			//glNormal3f(0,-1,0);
            glTexCoord2f(0.0f, 1.0f);
			glVertex3f(-sizeTex, sizeTex-skyCorection, sizeTex);
			//glNormal3f(0,-1,0);
            glTexCoord2f(0.0f, 0.0f);
			glVertex3f(-sizeTex, sizeTex-skyCorection, -sizeTex);
		glEnd();
	    
		glBindTexture(GL_TEXTURE_2D, sky[2]);
		glBegin(GL_QUADS);
			//glNormal3f(0,0,-1);
            glTexCoord2f(1.0f, 1.0f);
			glVertex3f(-sizeTex, sizeTex, sizeTex-skyCorection);
			//glNormal3f(0,0,1);
            glTexCoord2f(0.0f, 1.0f);
			glVertex3f(sizeTex, sizeTex, sizeTex-skyCorection);
			//glNormal3f(0,0,-1);
            glTexCoord2f(0.0f, 0.0f);
			glVertex3f(sizeTex, -sizeTex, sizeTex-skyCorection);
			//glNormal3f(0,0,-1);
            glTexCoord2f(1.0f, 0.0f);
			glVertex3f(-sizeTex, -sizeTex, sizeTex-skyCorection);
		glEnd();
	    
		glBindTexture(GL_TEXTURE_2D, sky[5]);
		glBegin(GL_QUADS);
			//glNormal3f(0,1,0);
            glTexCoord2f(1.0f, 0.0f);
			glVertex3f(-sizeTex, -sizeTex+skyCorection, -sizeTex);
			//glNormal3f(0,1,0);
            glTexCoord2f(1.0f, 1.0f);
			glVertex3f(-sizeTex, -sizeTex+skyCorection, sizeTex);
			//glNormal3f(0,1,0);
            glTexCoord2f(0.0f, 1.0f);
			glVertex3f(sizeTex, -sizeTex+skyCorection, sizeTex);
			//glNormal3f(0,1,0);
            glTexCoord2f(0.0f, 0.0f);
			glVertex3f(sizeTex, -sizeTex+skyCorection, -sizeTex);
		glEnd();
	    
		glBindTexture(GL_TEXTURE_2D, sky[6]);
		glBegin(GL_QUADS);
			//glNormal3f(-1,0,0);
            glTexCoord2f(1.0f, 0.0f);
			glVertex3f(sizeTex-skyCorection, -sizeTex, -sizeTex);
			//glNormal3f(-1,0,0);
            glTexCoord2f(1.0f, 1.0f);
			glVertex3f(sizeTex-skyCorection, -sizeTex, sizeTex);
			//glNormal3f(-1,0,0);
            glTexCoord2f(0.0f, 1.0f);
			glVertex3f(sizeTex-skyCorection, sizeTex, sizeTex);
			//glNormal3f(-1,0,0);
            glTexCoord2f(0.0f, 0.0f);
			glVertex3f(sizeTex-skyCorection, sizeTex, -sizeTex);
		glEnd();
    
    glTranslatef(-2000,2000,-13);
    glRotatef(180,1.0,0.0,0.0);    
    glBindTexture(GL_TEXTURE_2D, sky[0]);
    glBegin(GL_QUADS);
	for(int x = 0; x < 719; x++ )
	{
		for(int y = 0; y < 1; y++ )
		{
			float_x = float(x)/11.0f;
			float_y = float(y)/0.0125f;
			float_xb = float(x+1)/11.0f;
			float_yb = float(y+1)/0.0125f;

			//glNormal3f(0,0,-1);
            glTexCoord2f( float_x, float_y);
			glVertex3f( water[x][y][0], water[x][y][1], water[x][y][2] );

			//glNormal3f(0,0,-1);
            glTexCoord2f( float_x, float_yb );
			glVertex3f( water[x][y+1][0], water[x][y+1][1], water[x][y+1][2] );

			//glNormal3f(0,0,-1);
            glTexCoord2f( float_xb, float_yb );
			glVertex3f( water[x+1][y+1][0], water[x+1][y+1][1], water[x+1][y+1][2] );

			//glNormal3f(0,0,-1);
            glTexCoord2f( float_xb, float_y );
			glVertex3f( water[x+1][y][0], water[x+1][y][1], water[x+1][y][2] );
		}
	}
	glEnd();	
	glRotatef(-180,1.0,0.0,0.0);
    glTranslatef(2000,-2000,13);
    if (light == true) {
       glEnable (GL_LIGHTING);
    }
    
    for (int i = 0; i < 29; i++) {    
        glTranslatef(positionM[i][0],positionM[i][1],positionM[i][2]);
        glRotatef(positionM[i][3],0.0,0.0,1.0);
        glBindTexture(GL_TEXTURE_2D, modelV[i].id_texture);        
        glBegin(GL_TRIANGLES);   
        for (l_index=0;l_index<modelV[i].polygons_qty;l_index++)
        {   
            if (light == true) {
            glNormal3f( modelV[i].normal[ modelV[i].polygon[l_index].a ].x,
					    modelV[i].normal[ modelV[i].polygon[l_index].a ].y,
					    modelV[i].normal[ modelV[i].polygon[l_index].a ].z);
            }
            glTexCoord2f( modelV[i].mapcoord[ modelV[i].polygon[l_index].a ].u,
                          modelV[i].mapcoord[ modelV[i].polygon[l_index].a ].v);
            glVertex3f( modelV[i].vertex[ modelV[i].polygon[l_index].a ].x,
                        modelV[i].vertex[ modelV[i].polygon[l_index].a ].y,
                        modelV[i].vertex[ modelV[i].polygon[l_index].a ].z);
    
            if (light == true) {
            glNormal3f( modelV[i].normal[ modelV[i].polygon[l_index].b ].x,
    					modelV[i].normal[ modelV[i].polygon[l_index].b ].y,
    					modelV[i].normal[ modelV[i].polygon[l_index].b ].z);
            }
            glTexCoord2f( modelV[i].mapcoord[ modelV[i].polygon[l_index].b ].u,
                          modelV[i].mapcoord[ modelV[i].polygon[l_index].b ].v);
            glVertex3f( modelV[i].vertex[ modelV[i].polygon[l_index].b ].x,
                        modelV[i].vertex[ modelV[i].polygon[l_index].b ].y,
                        modelV[i].vertex[ modelV[i].polygon[l_index].b ].z);
            
            if (light == true) {
            glNormal3f( modelV[i].normal[ modelV[i].polygon[l_index].c ].x,
    					modelV[i].normal[ modelV[i].polygon[l_index].c ].y,
    					modelV[i].normal[ modelV[i].polygon[l_index].c ].z);
            }
            glTexCoord2f( modelV[i].mapcoord[ modelV[i].polygon[l_index].c ].u,
                          modelV[i].mapcoord[ modelV[i].polygon[l_index].c ].v);
            glVertex3f( modelV[i].vertex[ modelV[i].polygon[l_index].c ].x,
                        modelV[i].vertex[ modelV[i].polygon[l_index].c ].y,
                        modelV[i].vertex[ modelV[i].polygon[l_index].c ].z);
        }    
        glEnd();
        glRotatef(-positionM[i][3],0.0,0.0,1.0);
        glTranslatef(-positionM[i][0],-positionM[i][1],-positionM[i][2]);
    }
    
    for (int i = 0; i < 54; i++) {    
        glTranslatef(positionH[i][0],positionH[i][1],positionH[i][2]);
        glBindTexture(GL_TEXTURE_2D, housesV[i].id_texture);    
        if (mode == GL_SELECT) {
           glLoadName(100+i);
        }
        glBegin(GL_TRIANGLES);   
        for (l_index=0;l_index<housesV[i].polygons_qty;l_index++)
        {        
            if (light == true) {
            glNormal3f( housesV[i].normal[ housesV[i].polygon[l_index].a ].x,
					    housesV[i].normal[ housesV[i].polygon[l_index].a ].y,
					    housesV[i].normal[ housesV[i].polygon[l_index].a ].z);
            }
            glTexCoord2f( housesV[i].mapcoord[ housesV[i].polygon[l_index].a ].u,
                          housesV[i].mapcoord[ housesV[i].polygon[l_index].a ].v);
            glVertex3f( housesV[i].vertex[ housesV[i].polygon[l_index].a ].x,
                        housesV[i].vertex[ housesV[i].polygon[l_index].a ].y,
                        housesV[i].vertex[ housesV[i].polygon[l_index].a ].z);
    
            if (light == true) {
            glNormal3f( housesV[i].normal[ housesV[i].polygon[l_index].b ].x,
    					housesV[i].normal[ housesV[i].polygon[l_index].b ].y,
    					housesV[i].normal[ housesV[i].polygon[l_index].b ].z);
            }
            glTexCoord2f( housesV[i].mapcoord[ housesV[i].polygon[l_index].b ].u,
                          housesV[i].mapcoord[ housesV[i].polygon[l_index].b ].v);
            glVertex3f( housesV[i].vertex[ housesV[i].polygon[l_index].b ].x,
                        housesV[i].vertex[ housesV[i].polygon[l_index].b ].y,
                        housesV[i].vertex[ housesV[i].polygon[l_index].b ].z);
            
            if (light == true) {
            glNormal3f( housesV[i].normal[ housesV[i].polygon[l_index].c ].x,
    					housesV[i].normal[ housesV[i].polygon[l_index].c ].y,
    					housesV[i].normal[ housesV[i].polygon[l_index].c ].z);
            }
            glTexCoord2f( housesV[i].mapcoord[ housesV[i].polygon[l_index].c ].u,
                          housesV[i].mapcoord[ housesV[i].polygon[l_index].c ].v);
            glVertex3f( housesV[i].vertex[ housesV[i].polygon[l_index].c ].x,
                        housesV[i].vertex[ housesV[i].polygon[l_index].c ].y,
                        housesV[i].vertex[ housesV[i].polygon[l_index].c ].z);
        }    
        glEnd();
        glTranslatef(-positionH[i][0],-positionH[i][1],-positionH[i][2]);
    }
    
    for (int i = 0; i < 72; i++) {    
        glTranslatef(positionS[i][0],positionS[i][1],positionS[i][2]);
        glRotatef(positionS[i][3],0.0,0.0,1.0);
        glBindTexture(GL_TEXTURE_2D, streetsV[i].id_texture);    
        if (mode == GL_SELECT) {
           glLoadName(200+i);
        }
        glBegin(GL_TRIANGLES);   
        for (l_index=0;l_index<streetsV[i].polygons_qty;l_index++)
        {        
            if (light == true) {
            glNormal3f( streetsV[i].normal[ streetsV[i].polygon[l_index].a ].x,
					    streetsV[i].normal[ streetsV[i].polygon[l_index].a ].y,
					    streetsV[i].normal[ streetsV[i].polygon[l_index].a ].z);
            }
            glTexCoord2f( streetsV[i].mapcoord[ streetsV[i].polygon[l_index].a ].u,
                          streetsV[i].mapcoord[ streetsV[i].polygon[l_index].a ].v);
            glVertex3f( streetsV[i].vertex[ streetsV[i].polygon[l_index].a ].x,
                        streetsV[i].vertex[ streetsV[i].polygon[l_index].a ].y,
                        streetsV[i].vertex[ streetsV[i].polygon[l_index].a ].z);
    
            if (light == true) {
            glNormal3f( streetsV[i].normal[ streetsV[i].polygon[l_index].b ].x,
    					streetsV[i].normal[ streetsV[i].polygon[l_index].b ].y,
    					streetsV[i].normal[ streetsV[i].polygon[l_index].b ].z);
            }
            glTexCoord2f( streetsV[i].mapcoord[ streetsV[i].polygon[l_index].b ].u,
                          streetsV[i].mapcoord[ streetsV[i].polygon[l_index].b ].v);
            glVertex3f( streetsV[i].vertex[ streetsV[i].polygon[l_index].b ].x,
                        streetsV[i].vertex[ streetsV[i].polygon[l_index].b ].y,
                        streetsV[i].vertex[ streetsV[i].polygon[l_index].b ].z);
            
            if (light == true) {
            glNormal3f( streetsV[i].normal[ streetsV[i].polygon[l_index].c ].x,
    					streetsV[i].normal[ streetsV[i].polygon[l_index].c ].y,
    					streetsV[i].normal[ streetsV[i].polygon[l_index].c ].z);
            }
            glTexCoord2f( streetsV[i].mapcoord[ streetsV[i].polygon[l_index].c ].u,
                          streetsV[i].mapcoord[ streetsV[i].polygon[l_index].c ].v);
            glVertex3f( streetsV[i].vertex[ streetsV[i].polygon[l_index].c ].x,
                        streetsV[i].vertex[ streetsV[i].polygon[l_index].c ].y,
                        streetsV[i].vertex[ streetsV[i].polygon[l_index].c ].z);
        }    
        glEnd();
        glRotatef(-positionS[i][3],0.0,0.0,1.0);
        glTranslatef(-positionS[i][0],-positionS[i][1],-positionS[i][2]);
    }
    if (light == true) {
       glDisable (GL_LIGHTING);
    }
    if (portSign == true && playersChoice == false) {
        for (int i = 0; i < 9; i++) {
            glTranslatef(positionW[i][0],positionW[i][1],positionW[i][2]);
            glPushMatrix();
            glRotatef(-30,0.0,0.0,1.0);
        	glRotatef(90,1.0,0.0,0.0);
            glRotatef(-rY,0.0,1.0,0.0);
            glRotatef(-rX,1.0,0.0,0.0);
            glBindTexture(GL_TEXTURE_2D, portV[i].id_texture);        
            glBegin(GL_TRIANGLES);
            for (l_index=0;l_index<2;l_index++)
            {
                /*glNormal3f( portV[i].normal[ portV[i].polygon[l_index].a ].x,
    					    portV[i].normal[ portV[i].polygon[l_index].a ].y,
    					    portV[i].normal[ portV[i].polygon[l_index].a ].z);*/
                glTexCoord2f( portV[i].mapcoord[ portV[i].polygon[l_index].a ].u,
                              portV[i].mapcoord[ portV[i].polygon[l_index].a ].v);
                glVertex3f( portV[i].vertex[ portV[i].polygon[l_index].a ].x,
                            portV[i].vertex[ portV[i].polygon[l_index].a ].y,
                            portV[i].vertex[ portV[i].polygon[l_index].a ].z);
        
                /*glNormal3f( portV[i].normal[ portV[i].polygon[l_index].b ].x,
        					portV[i].normal[ portV[i].polygon[l_index].b ].y,
        					portV[i].normal[ portV[i].polygon[l_index].b ].z);*/
                glTexCoord2f( portV[i].mapcoord[ portV[i].polygon[l_index].b ].u,
                              portV[i].mapcoord[ portV[i].polygon[l_index].b ].v);
                glVertex3f( portV[i].vertex[ portV[i].polygon[l_index].b ].x,
                            portV[i].vertex[ portV[i].polygon[l_index].b ].y,
                            portV[i].vertex[ portV[i].polygon[l_index].b ].z);
                
                /*glNormal3f( portV[i].normal[ portV[i].polygon[l_index].c ].x,
        					portV[i].normal[ portV[i].polygon[l_index].c ].y,
        					portV[i].normal[ portV[i].polygon[l_index].c ].z);*/
                glTexCoord2f( portV[i].mapcoord[ portV[i].polygon[l_index].c ].u,
                              portV[i].mapcoord[ portV[i].polygon[l_index].c ].v);
                glVertex3f( portV[i].vertex[ portV[i].polygon[l_index].c ].x,
                            portV[i].vertex[ portV[i].polygon[l_index].c ].y,
                            portV[i].vertex[ portV[i].polygon[l_index].c ].z);
            }
            glEnd();
            glPopMatrix();
            glTranslatef(-positionW[i][0],-positionW[i][1],-positionW[i][2]);
        }
    }
    for (int i = 0; i < 20; i++) {
        glTranslatef(positionP[i][0],positionP[i][1],positionP[i][2]);
        glPushMatrix();
        glRotatef(-30,0.0,0.0,1.0);
    	glRotatef(90,1.0,0.0,0.0);
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);
        glBindTexture(GL_TEXTURE_2D, pointerV[i].id_texture);        
        glBegin(GL_TRIANGLES);
        for (l_index=0;l_index<1;l_index++)
        {
            /*glNormal3f( pointerV[i].normal[ pointerV[i].polygon[l_index].a ].x,
					    pointerV[i].normal[ pointerV[i].polygon[l_index].a ].y,
					    pointerV[i].normal[ pointerV[i].polygon[l_index].a ].z);*/
            glTexCoord2f( pointerV[i].mapcoord[ pointerV[i].polygon[l_index].a ].u,
                          pointerV[i].mapcoord[ pointerV[i].polygon[l_index].a ].v);
            glVertex3f( pointerV[i].vertex[ pointerV[i].polygon[l_index].a ].x,
                        pointerV[i].vertex[ pointerV[i].polygon[l_index].a ].y,
                        pointerV[i].vertex[ pointerV[i].polygon[l_index].a ].z);
    
            /*glNormal3f( pointerV[i].normal[ pointerV[i].polygon[l_index].b ].x,
    					pointerV[i].normal[ pointerV[i].polygon[l_index].b ].y,
    					pointerV[i].normal[ pointerV[i].polygon[l_index].b ].z);*/
            glTexCoord2f( pointerV[i].mapcoord[ pointerV[i].polygon[l_index].b ].u,
                          pointerV[i].mapcoord[ pointerV[i].polygon[l_index].b ].v);
            glVertex3f( pointerV[i].vertex[ pointerV[i].polygon[l_index].b ].x,
                        pointerV[i].vertex[ pointerV[i].polygon[l_index].b ].y,
                        pointerV[i].vertex[ pointerV[i].polygon[l_index].b ].z);
            
            /*glNormal3f( pointerV[i].normal[ pointerV[i].polygon[l_index].c ].x,
    					pointerV[i].normal[ pointerV[i].polygon[l_index].c ].y,
    					pointerV[i].normal[ pointerV[i].polygon[l_index].c ].z);*/
            glTexCoord2f( pointerV[i].mapcoord[ pointerV[i].polygon[l_index].c ].u,
                          pointerV[i].mapcoord[ pointerV[i].polygon[l_index].c ].v);
            glVertex3f( pointerV[i].vertex[ pointerV[i].polygon[l_index].c ].x,
                        pointerV[i].vertex[ pointerV[i].polygon[l_index].c ].y,
                        pointerV[i].vertex[ pointerV[i].polygon[l_index].c ].z);
        }
        glEnd();
        glPopMatrix();
        glTranslatef(-positionP[i][0],-positionP[i][1],-positionP[i][2]);
    }
    
    if (numberShow == true && playersChoice == false) {
    	glRotatef(-30,0.0,0.0,1.0);
    	glRotatef(90,1.0,0.0,0.0);
        glScalef(0.05,0.05,0.05);	
        
        glTranslatef(-10,500,0);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[0]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(10,-500,0);
    	
    	glTranslatef(500,500,-900);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[1]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(-500,-500,900);
    	
    	glTranslatef(1000,500,0);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[2]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(-1000,-500,0);
    	
    	glTranslatef(500,500,900);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[3]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(-500,-500,-900);
    	
    	glTranslatef(-500,500,900);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[4]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(500,-500,-900);
    	
    	glTranslatef(-1000,500,0);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[5]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(1000,-500,0);
    	
    	glTranslatef(-500,500,-900);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[6]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(500,-500,900);
    	
    	glTranslatef(0,500,-1800);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[7]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(0,-500,1800);
        
        glTranslatef(1000,500,-1800);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[8]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(-1000,-500,1800);
    	
    	glTranslatef(1500,500,-900);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[9]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(-1500,-500,900);
    	
    	glTranslatef(2000,500,0);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[10]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(-2000,-500,0);
    	
    	glTranslatef(1500,500,900);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[11]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(-1500,-500,-900);
    	
    	glTranslatef(1000,500,1800);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[12]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(-1000,-500,-1800);
    	
    	glTranslatef(0,500,1800);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[13]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(0,-500,-1800);
    	
    	glTranslatef(-1000,500,1800);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[14]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(1000,-500,-1800);
    	
    	glTranslatef(-1500,500,900);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[15]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(1500,-500,-900);
    	
    	glTranslatef(-2000,500,0);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[16]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(2000,-500,0);
    	
    	glTranslatef(-1500,500,-900);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[17]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(1500,-500,900);
    	
    	glTranslatef(-1000,500,-1800);
        glPushMatrix();
        glRotatef(-rY,0.0,1.0,0.0);
        glRotatef(-rX,1.0,0.0,0.0);    
        sprintf(s,"%u",number[18]);
        renderStrokeCharacter(-100,0,0,(void *)font3D,s);
    	glPopMatrix();
    	glTranslatef(1000,-500,1800);    	    	
    }
    glPopMatrix();
    
    glPushMatrix();    
    for (int i = 0; i < 72; i++) {
        glTranslatef(positionI[i][0],positionI[i][1],positionI[i][2]);
        glBindTexture(GL_TEXTURE_2D, interfaceV[i].id_texture);
        if (mode == GL_SELECT) {
           glLoadName(300+i);
        }
        glBegin(GL_TRIANGLES);
        for (l_index=0;l_index<2;l_index++)
        {
            /*glNormal3f( interfaceV[i].normal[ interfaceV[i].polygon[l_index].a ].x,
					    interfaceV[i].normal[ interfaceV[i].polygon[l_index].a ].y,
					    interfaceV[i].normal[ interfaceV[i].polygon[l_index].a ].z);*/
            glTexCoord2f( interfaceV[i].mapcoord[ interfaceV[i].polygon[l_index].a ].u,
                          interfaceV[i].mapcoord[ interfaceV[i].polygon[l_index].a ].v);
            glVertex3f( interfaceV[i].vertex[ interfaceV[i].polygon[l_index].a ].x,
                        interfaceV[i].vertex[ interfaceV[i].polygon[l_index].a ].y,
                        interfaceV[i].vertex[ interfaceV[i].polygon[l_index].a ].z);
    
            /*glNormal3f( interfaceV[i].normal[ interfaceV[i].polygon[l_index].b ].x,
    					interfaceV[i].normal[ interfaceV[i].polygon[l_index].b ].y,
    					interfaceV[i].normal[ interfaceV[i].polygon[l_index].b ].z);*/
            glTexCoord2f( interfaceV[i].mapcoord[ interfaceV[i].polygon[l_index].b ].u,
                          interfaceV[i].mapcoord[ interfaceV[i].polygon[l_index].b ].v);
            glVertex3f( interfaceV[i].vertex[ interfaceV[i].polygon[l_index].b ].x,
                        interfaceV[i].vertex[ interfaceV[i].polygon[l_index].b ].y,
                        interfaceV[i].vertex[ interfaceV[i].polygon[l_index].b ].z);
            
            /*glNormal3f( interfaceV[i].normal[ interfaceV[i].polygon[l_index].c ].x,
    					interfaceV[i].normal[ interfaceV[i].polygon[l_index].c ].y,
    					interfaceV[i].normal[ interfaceV[i].polygon[l_index].c ].z);*/
            glTexCoord2f( interfaceV[i].mapcoord[ interfaceV[i].polygon[l_index].c ].u,
                          interfaceV[i].mapcoord[ interfaceV[i].polygon[l_index].c ].v);
            glVertex3f( interfaceV[i].vertex[ interfaceV[i].polygon[l_index].c ].x,
                        interfaceV[i].vertex[ interfaceV[i].polygon[l_index].c ].y,
                        interfaceV[i].vertex[ interfaceV[i].polygon[l_index].c ].z);
        }
        glEnd(); 
        glTranslatef(-positionI[i][0],-positionI[i][1],-positionI[i][2]);
    }
    glPopMatrix();    
    
        
    glPushMatrix();    
    setOrthographicProjection();
    glLoadIdentity();
    glColor3f(1,1,1);
    switch(player) {        
        case 1:
             glColor3f(1,0,0);
             break;
        
        case 2:
             glColor3f(0,0,1);
             break;
        
        case 3:
             glColor3f(0,1,0);
             break;
        
        case 4:
             glColor3f(1,0,1);
             break;
    }
    if (playerKI[player] == true) {
       sprintf(s,"Comp. %u",player);
       renderBitmapString(xInterface * 13.5,yInterface * 95.5,(void *)font,s);
    } else {
       sprintf(s,"Spieler %u",player);
       renderBitmapString(xInterface * 13.5,yInterface * 95.5,(void *)font,s);
    }
    glColor3f(1,1,0.3);
    sprintf(s,"%u",resources[player][0]);
    renderBitmapString(xInterface * 15.5,yInterface * 101,(void *)font,s);
    sprintf(s,"/%u",winPoints);
    renderBitmapString(xInterface * 18,yInterface * 101,(void *)font,s);
    sprintf(s,"%u",resources[player][1]);
    renderBitmapString(xInterface * 25,yInterface * 101,(void *)font,s);
    sprintf(s,"%u",resources[player][2]);
    renderBitmapString(xInterface * 30,yInterface * 101,(void *)font,s);
    sprintf(s,"%u",resources[player][3]);
    renderBitmapString(xInterface * 35,yInterface * 101,(void *)font,s);
    sprintf(s,"%u",resources[player][4]);
    renderBitmapString(xInterface * 40,yInterface * 101,(void *)font,s);
    sprintf(s,"%u",resources[player][5]);
    renderBitmapString(xInterface * 45,yInterface * 101,(void *)font,s);
    sprintf(s,"Punkte");
    renderBitmapString(xInterface * 14,yInterface * 98.3,(void *)font,s);
    glColor3f(1,1,1);
    if (next == true && trade == true) {
       if (kiTurn > 0) {
          glColor3f(1,1,0.3);
       }
       sprintf(s,"%u",tradeArray[0][1]);
       renderBitmapString(xInterface * 53,yInterface * 34.9,(void *)font,s);
       sprintf(s,"%u",tradeArray[1][1]);
       renderBitmapString(xInterface * 53,yInterface * 42.5,(void *)font,s);
       sprintf(s,"%u",tradeArray[2][1]);
       renderBitmapString(xInterface * 53,yInterface * 50.3,(void *)font,s);
       sprintf(s,"%u",tradeArray[3][1]);
       renderBitmapString(xInterface * 53,yInterface * 57.9,(void *)font,s);
       sprintf(s,"%u",tradeArray[4][1]);
       renderBitmapString(xInterface * 53,yInterface * 65.7,(void *)font,s);
       if (tradePlayer == 0) {
          glColor3f(1,1,0.3);
       }
       sprintf(s,"%u",tradeArray[0][0]);
       renderBitmapString(xInterface * 73.5,yInterface * 34.9,(void *)font,s);
       sprintf(s,"%u",tradeArray[1][0]);
       renderBitmapString(xInterface * 73.5,yInterface * 42.5,(void *)font,s);
       sprintf(s,"%u",tradeArray[2][0]);
       renderBitmapString(xInterface * 73.5,yInterface * 50.3,(void *)font,s);
       sprintf(s,"%u",tradeArray[3][0]);
       renderBitmapString(xInterface * 73.5,yInterface * 57.9,(void *)font,s);
       sprintf(s,"%u",tradeArray[4][0]);
       renderBitmapString(xInterface * 73.5,yInterface * 65.7,(void *)font,s);
       if (tradePlayer == 0) {
          glColor3f(1,1,1);
       }
       switch(tradePlayer) {
          case 0:
               if (kiTurn > 0) {
                   glColor3f(1,1,0.3);
               }
               sprintf(s,">");
               renderBitmapString(xInterface * 59,yInterface * 39,(void *)font,s);
               glColor3f(1,1,0.3);
               sprintf(s,"%u:1",tradeStep[0]);
               renderBitmapString(xInterface * 77,yInterface * 31.3,(void *)font,s);
               sprintf(s,"%u:1",tradeStep[1]);
               renderBitmapString(xInterface * 77,yInterface * 39,(void *)font,s);
               sprintf(s,"%u:1",tradeStep[2]);
               renderBitmapString(xInterface * 77,yInterface * 46.7,(void *)font,s);
               sprintf(s,"%u:1",tradeStep[3]);
               renderBitmapString(xInterface * 77,yInterface * 54.5,(void *)font,s);
               sprintf(s,"%u:1",tradeStep[4]);
               renderBitmapString(xInterface * 77,yInterface * 62,(void *)font,s);
               glColor3f(1,1,1);
               if (kiTurn > 0) {
                   glColor3f(1,1,0.3);
               }
               switch(tradeItem) {
                   case 0:
                        sprintf(s,">");
                        renderBitmapString(xInterface * 71,yInterface * 31.3,(void *)font,s);
                        break;
                   
                   case 1:
                        sprintf(s,">");
                        renderBitmapString(xInterface * 71,yInterface * 39,(void *)font,s);
                        break;
                   
                   case 2:
                        sprintf(s,">");
                        renderBitmapString(xInterface * 71,yInterface * 46.7,(void *)font,s);
                        break;
                   
                   case 3:
                        sprintf(s,">");
                        renderBitmapString(xInterface * 71,yInterface * 54.5,(void *)font,s);
                        break;
                   
                   case 4:
                        sprintf(s,">");
                        renderBitmapString(xInterface * 71,yInterface * 62,(void *)font,s);
                        break;
               }
               break;
          
          case 1:
               sprintf(s,">");
               renderBitmapString(xInterface * 59,yInterface * 44,(void *)font,s);
               break;
          
          case 2:
               sprintf(s,">");
               renderBitmapString(xInterface * 59,yInterface * 49.2,(void *)font,s);
               break;
          
          case 3:
               sprintf(s,">");
               renderBitmapString(xInterface * 59,yInterface * 54.4,(void *)font,s);
               break;
          
          case 4:
               sprintf(s,">");
               renderBitmapString(xInterface * 59,yInterface * 59.6,(void *)font,s);
               break;          
       }
       glColor3f(1,1,0.3);
       if (tradePlayer > 0) {
           sprintf(s,"%u/",resources[tradePlayer][1]);
           renderBitmapString(xInterface * 48.7,yInterface * 31.3,(void *)font,s);
           sprintf(s,"%u/",resources[tradePlayer][2]);
           renderBitmapString(xInterface * 48.7,yInterface * 39,(void *)font,s);
           sprintf(s,"%u/",resources[tradePlayer][3]);
           renderBitmapString(xInterface * 48.7,yInterface * 46.7,(void *)font,s);
           sprintf(s,"%u/",resources[tradePlayer][4]);
           renderBitmapString(xInterface * 48.7,yInterface * 54.5,(void *)font,s);
           sprintf(s,"%u/",resources[tradePlayer][5]);
           renderBitmapString(xInterface * 48.7,yInterface * 62,(void *)font,s);
           sprintf(s,"/%u",resources[player][1]);
           renderBitmapString(xInterface * 77,yInterface * 31.3,(void *)font,s);
           sprintf(s,"/%u",resources[player][2]);
           renderBitmapString(xInterface * 77,yInterface * 39,(void *)font,s);
           sprintf(s,"/%u",resources[player][3]);
           renderBitmapString(xInterface * 77,yInterface * 46.7,(void *)font,s);
           sprintf(s,"/%u",resources[player][4]);
           renderBitmapString(xInterface * 77,yInterface * 54.5,(void *)font,s);
           sprintf(s,"/%u",resources[player][5]);
           renderBitmapString(xInterface * 77,yInterface * 62,(void *)font,s);
       }
       sprintf(s,"Incoming");
       renderBitmapString(xInterface * 49.2,yInterface * 26,(void *)font,s);
       sprintf(s,"Outgoing");
       renderBitmapString(xInterface * 69.5,yInterface * 26,(void *)font,s);
       if (kiTurn == 0) {
           glColor3f(1,1,1);
       }
       sprintf(s,"Hafen");
       renderBitmapString(xInterface * 60.7,yInterface * 39,(void *)font,s);
       glColor3f(1,1,1);
    }
    if (playersChoice == true) {
        sprintf(s,"Start");
        renderBitmapString(xInterface * 61.6,yInterface * 62.3,(void *)font,s);
        if (playerKI[1] == false) {
           glColor3f(1,0,0);
        }
        sprintf(s,"Spieler 1");
        renderBitmapString(xInterface * 52,yInterface * 39.1,(void *)font,s);
        if (playerKI[1] == false) {
           glColor3f(1,1,1);
           sprintf(s,"<");
           renderBitmapString(xInterface * 62.6,yInterface * 39.1,(void *)font,s);
        } else {
           sprintf(s,">");
           renderBitmapString(xInterface * 64.1,yInterface * 39.1,(void *)font,s);
           glColor3f(1,0,0);
        }
        sprintf(s,"Comp. 1");
        renderBitmapString(xInterface * 67.4,yInterface * 39.1,(void *)font,s);
        if (playerKI[1] == true) {
           glColor3f(1,1,1);
        }
        if (playersPicked > 1) {
           if (playerKI[2] == false) {
              glColor3f(0,0,1);
           }
           sprintf(s,"Spieler 2");
           renderBitmapString(xInterface * 52,yInterface * 44.2,(void *)font,s);
           if (playerKI[2] == false) {
              glColor3f(1,1,1);
              sprintf(s,"<");
              renderBitmapString(xInterface * 62.6,yInterface * 44.2,(void *)font,s);
           } else {
              sprintf(s,">");
              renderBitmapString(xInterface * 64.1,yInterface * 44.2,(void *)font,s);
              glColor3f(0,0,1);
           }
           sprintf(s,"Comp. 2");
           renderBitmapString(xInterface * 67.4,yInterface * 44.2,(void *)font,s);
           if (playerKI[2] == true) {
              glColor3f(1,1,1);
           }
        }
        if (playersPicked > 2) {
           if (playerKI[3] == false) {
              glColor3f(0.4,0.91,0);
           }
           sprintf(s,"Spieler 3");
           renderBitmapString(xInterface * 52,yInterface * 49.3,(void *)font,s);
           if (playerKI[3] == false) {
              glColor3f(1,1,1);
              sprintf(s,"<");
              renderBitmapString(xInterface * 62.6,yInterface * 49.3,(void *)font,s);
           } else {
              sprintf(s,">");
              renderBitmapString(xInterface * 64.1,yInterface * 49.3,(void *)font,s);
              glColor3f(0.4,0.91,0);
           }
           sprintf(s,"Comp. 3");
           renderBitmapString(xInterface * 67.4,yInterface * 49.3,(void *)font,s);
           if (playerKI[3] == true) {
              glColor3f(1,1,1);
           }
        }
        if (playersPicked > 3) {
           if (playerKI[4] == false) {
              glColor3f(0.51,0,0.91);
           }
           sprintf(s,"Spieler 4");
           renderBitmapString(xInterface * 52,yInterface * 54.4,(void *)font,s);
           if (playerKI[4] == false) {
              glColor3f(1,1,1);
              sprintf(s,"<");
              renderBitmapString(xInterface * 62.6,yInterface * 54.4,(void *)font,s);
           } else {
              sprintf(s,">");
              renderBitmapString(xInterface * 64.1,yInterface * 54.4,(void *)font,s);
              glColor3f(0.51,0,0.91);
           }
           sprintf(s,"Comp. 4");
           renderBitmapString(xInterface * 67.4,yInterface * 54.4,(void *)font,s);
           if (playerKI[4] == true) {
              glColor3f(1,1,1);
           }
        }
    }
    if (win == true) {
        switch(player) {            
            case 1:
                 glColor3f(1,0,0);
                 break;
            
            case 2:
                 glColor3f(0,0,1);
                 break;
            
            case 3:
                 glColor3f(0,1,0);
                 break;
            
            case 4:
                 glColor3f(1,0,1);
                 break;
        }
        if (playerKI[player] == true) {
           sprintf(s,"Comp. %u",player);
           renderBitmapString(xInterface * 43,yInterface * 50,(void *)font,s);
        } else {
           sprintf(s,"Spieler %u",player);
           renderBitmapString(xInterface * 43,yInterface * 50,(void *)font,s);
        }
        glColor3f(1,1,1);
        sprintf(s,"hat im");
        renderBitmapString(xInterface * 52,yInterface * 50,(void *)font,s);
        glColor3f(1,1,0.3);
        sprintf(s,"%u",runde);
        renderBitmapString(xInterface * 58.7,yInterface * 50,(void *)font,s);
        glColor3f(1,1,1);
        sprintf(s,"ten Spielzug gewonnen!",runde);
        renderBitmapString(xInterface * 61.2,yInterface * 50,(void *)font,s);
    }
    if (fps == true) {        
        glColor3f(0,0,0);
        sprintf(s, "%.2f",frameRate);
        renderBitmapString(xInterface * 1,yInterface * 3,(void *)font,s);
        glColor3f(1,1,1);
    }
    if (kiTurn == 0) {
        if (interfaceToggle == true) {
           glColor3f(0.3,0.3,0.3);
        }
        sprintf(s,"Baukosten");
        renderBitmapString(xInterface * 1.2,yInterface * 96.5,(void *)font,s);
        if (interfaceToggle == true) {
           glColor3f(1,1,1);
        }
        if (options == true) {
           glColor3f(0.3,0.3,0.3);
        }
        sprintf(s,"Optionen");
        renderBitmapString(xInterface * 1.7,yInterface * 100.5,(void *)font,s);
        if (options == true) {
           glColor3f(1,1,1);
        }
        if (options == true) {
           sprintf(s,"Licht");
           renderBitmapString(xInterface * 7,yInterface * 31.5,(void *)font,s);
           sprintf(s,"Frames");
           renderBitmapString(xInterface * 7,yInterface * 36.5,(void *)font,s);
           sprintf(s,"Wire");
           renderBitmapString(xInterface * 7,yInterface * 41.7,(void *)font,s);
           sprintf(s,"Center");
           renderBitmapString(xInterface * 7,yInterface * 46.9,(void *)font,s);
           sprintf(s,"Zahlen");
           renderBitmapString(xInterface * 7,yInterface * 52.1,(void *)font,s);
           sprintf(s,"Zeichen");
           renderBitmapString(xInterface * 7,yInterface * 57.3,(void *)font,s);
           if (light == true) {
              sprintf(s,">");
              renderBitmapString(xInterface * 5.5,yInterface * 31.5,(void *)font,s);
           }
           if (fps == true) {
              sprintf(s,">");
              renderBitmapString(xInterface * 5.5,yInterface * 36.5,(void *)font,s);
           }
           if (wire == true) {
              sprintf(s,">");
              renderBitmapString(xInterface * 5.5,yInterface * 41.7,(void *)font,s);
           }
           if (rX == 90 && rY == 0 && zoom == -380 && trans1 == 0 && trans2 == 0) {
              sprintf(s,">");
              renderBitmapString(xInterface * 5.5,yInterface * 46.9,(void *)font,s);
           }
           if (numberShow == true) {
              sprintf(s,">");
              renderBitmapString(xInterface * 5.5,yInterface * 52.1,(void *)font,s);
           }
           if (portSign == true) {
              sprintf(s,">");
              renderBitmapString(xInterface * 5.5,yInterface * 57.3,(void *)font,s);
           }
        }
        if (wuerfeln == true) {
           sprintf(s,"Wuerfeln");
           renderBitmapString(xInterface * 85,yInterface * 98,(void *)font,s);        
        }
        if (next == true && trade == false && build == false) {
           glColor3f(1,1,0.3);
           sprintf(s,"+");
           renderBitmapString(xInterface * 62,yInterface * 98,(void *)font,s);
           sprintf(s,"= %u",zufall);
           renderBitmapString(xInterface * 75,yInterface * 98,(void *)font,s);
           glColor3f(1,1,1);
           sprintf(s,"Naechster");
           renderBitmapString(xInterface * 97.3,yInterface * 98,(void *)font,s);
           sprintf(s,"Handeln");
           renderBitmapString(xInterface * 85.3,yInterface * 98,(void *)font,s);       
        }
        if (next == true && trade == true) {
           switch(player) {
              case 1:
                   if (playerKI[2] == false && playersPicked > 1) {
                       glColor3f(0,0,1);
                       sprintf(s,"Spieler 2");
                       renderBitmapString(xInterface * 60.7,yInterface * 49.2,(void *)font,s);
                   }
                   if (playerKI[3] == false && playersPicked > 2) {
                       glColor3f(0.4,0.91,0);
                       sprintf(s,"Spieler 3");
                       renderBitmapString(xInterface * 60.7,yInterface * 54.4,(void *)font,s);
                   }
                   if (playerKI[4] == false && playersPicked > 3) {
                       glColor3f(0.51,0,0.91);
                       sprintf(s,"Spieler 4");
                       renderBitmapString(xInterface * 60.7,yInterface * 59.6,(void *)font,s);
                   }
                   glColor3f(1,1,1);
                   break;
              
              case 2:
                   if (playerKI[1] == false) {
                       glColor3f(1,0,0);
                       sprintf(s,"Spieler 1");
                       renderBitmapString(xInterface * 60.7,yInterface * 44,(void *)font,s);
                   }
                   if (playerKI[3] == false && playersPicked > 2) {
                       glColor3f(0.4,0.91,0);
                       sprintf(s,"Spieler 3");
                       renderBitmapString(xInterface * 60.7,yInterface * 54.4,(void *)font,s);
                   }
                   if (playerKI[4] == false && playersPicked > 3) {
                       glColor3f(0.51,0,0.91);
                       sprintf(s,"Spieler 4");
                       renderBitmapString(xInterface * 60.7,yInterface * 59.6,(void *)font,s);
                   }
                   glColor3f(1,1,1);
                   break;
              
              case 3:
                   if (playerKI[1] == false) {
                       glColor3f(1,0,0);
                       sprintf(s,"Spieler 1");
                       renderBitmapString(xInterface * 60.7,yInterface * 44,(void *)font,s);
                   }
                   if (playerKI[2] == false) {
                       glColor3f(0,0,1);
                       sprintf(s,"Spieler 2");
                       renderBitmapString(xInterface * 60.7,yInterface * 49.2,(void *)font,s);
                   }
                   if (playerKI[4] == false && playersPicked > 3) {
                       glColor3f(0.51,0,0.91);
                       sprintf(s,"Spieler 4");
                       renderBitmapString(xInterface * 60.7,yInterface * 59.6,(void *)font,s);
                   }
                   glColor3f(1,1,1);
                   break;
              
              case 4:
                   if (playerKI[1] == false) {
                       glColor3f(1,0,0);
                       sprintf(s,"Spieler 1");
                       renderBitmapString(xInterface * 60.7,yInterface * 44,(void *)font,s);
                   }
                   if (playerKI[2] == false) {
                       glColor3f(0,0,1);
                       sprintf(s,"Spieler 2");
                       renderBitmapString(xInterface * 60.7,yInterface * 49.2,(void *)font,s);
                   }
                   if (playerKI[3] == false) {
                       glColor3f(0.4,0.91,0);
                       sprintf(s,"Spieler 3");
                       renderBitmapString(xInterface * 60.7,yInterface * 54.4,(void *)font,s);
                   }
                   glColor3f(1,1,1);
                   break;          
           }
           sprintf(s,"tauschen");
           renderBitmapString(xInterface * 59.6,yInterface * 72.4,(void *)font,s);
           sprintf(s,"Naechster");
           renderBitmapString(xInterface * 97.3,yInterface * 98,(void *)font,s);
           sprintf(s,"Bauen");
           renderBitmapString(xInterface * 86.4,yInterface * 98,(void *)font,s);
        }
        if (next == true && build == true) {
           sprintf(s,"Naechster");
           renderBitmapString(xInterface * 97.3,yInterface * 98,(void *)font,s);
        }
        sprintf(s,"Schliessen");
        renderBitmapString(xInterface * 115.2,yInterface * 98,(void *)font,s);
    }
    if (kiTurn > 2 && firstTime > (playersPicked * 4)) {
       glColor3f(1,1,0.3);
       sprintf(s,"+");
       renderBitmapString(xInterface * 62,yInterface * 98,(void *)font,s);
       sprintf(s,"= %u",zufall);
       renderBitmapString(xInterface * 75,yInterface * 98,(void *)font,s);
       glColor3f(1,1,1);
    }
    if (kiTurn > 0) {
       glColor3f(1,1,0.3);
       sprintf(s,"Computer speed:");
       renderBitmapString(xInterface * 1,yInterface * 6,(void *)font,s);
       if (fastForward == true) {
           sprintf(s,">>>");
           renderBitmapString(xInterface * 19,yInterface * 6,(void *)font,s);
       } else {
           sprintf(s,">");
           renderBitmapString(xInterface * 19,yInterface * 6,(void *)font,s);
       }
       glColor3f(1,1,1);
    }
    resetPerspectiveProjection();
    glPopMatrix();
    if (light == true) {
       glEnable (GL_LIGHTING);
    }
}

void processHits(GLint hits, GLuint buffer[])
{
   unsigned int i, j;
   GLuint names, *ptr, minZ,*ptrNames, numberOfNames, *ptrNamesPrev;
      
   ptr = (GLuint *) buffer;
   minZ = 0xffffffff;
   for (i = 0; i < hits; i++) {	
      names = *ptr;
	  ptr++;
	  if (*ptr < minZ) {
		  numberOfNames = names;
		  minZ = *ptr;
		  ptrNamesPrev = ptrNames;
          ptrNames = ptr+2;
	  }	  
	  ptr += names+2;
   }
   picked = *ptrNamesPrev;   
}

void mouse(int button, int state, int x, int y)
{
   const float ar = (float) width / (float) height;
   GLuint selectBuf[BUFSIZE];
   GLint hits;
   GLint viewport[4];
   
    switch (button) {
            
            case GLUT_LEFT_BUTTON:
                 if (kiTurn == 0) {
                     switch (state) {
                       
                       case GLUT_DOWN:                        
                            lButtonDown = true;
                            glGetIntegerv(GL_VIEWPORT, viewport);       
                            
                            glSelectBuffer(BUFSIZE, selectBuf);
                            (void) glRenderMode (GL_SELECT);
                                
                            glMatrixMode(GL_PROJECTION);
                            glPushMatrix();
                            glLoadIdentity();       
                            
                            gluPickMatrix((GLdouble) x, (GLdouble) (viewport[3] - y), 5.0, 5.0, viewport);
                            glFrustum(-ar, ar, -1.0, 1.0, 2.0, roomDistance);
                            glMatrixMode(GL_MODELVIEW);       
                            draw(GL_SELECT);       
                      	    glMatrixMode(GL_PROJECTION);
                            glPopMatrix();
                            glMatrixMode(GL_MODELVIEW);
                      	     
           	                glFlush();
                        
                            hits = glRenderMode(GL_RENDER);
                            if (hits != 0) {
                              processHits(hits, selectBuf);
                            }
                            break;
                            
                       case GLUT_UP:
                            lButtonDown = false;
                            lButtonOneTime = false;
                            break;                        
                     }
                 } else {
                     switch (state) {
                       
                       case GLUT_DOWN:                        
                            kiWait1 = 500;
                            kiWait2 = 1000;
                            fastForward = true;
                            break;
                            
                       case GLUT_UP:
                            kiWait1 = 1500;
                            kiWait2 = 3000;
                            fastForward = false;
                            break;                        
                     }
                 }
                 break;
                 
            case GLUT_MIDDLE_BUTTON:
                  switch (state) {
                    
                    case GLUT_DOWN:                        
                        z2 = zoom;
                        z1 = y;
                        mButtonDown = true;
                        break;
                    
                    case GLUT_UP:
                        mButtonDown = false;
                        break;
                  }
                 break;
                 
            case GLUT_RIGHT_BUTTON:
                 switch (state) {
                   
                   case GLUT_DOWN:                        
                        x2 = rX;
                        y2 = rY;
                        x1 = x;
                        y01 = y;                        
                        rButtonDown = true;
                        break;
                        
                   case GLUT_UP:
                        rButtonDown = false;
                        break;                        
                 }
                 break;            
     }
}

void mouseMotion(int x, int y) {
  
     
         if (rButtonDown == true) {
            if (rX <= yAngle && rX >= yBorder) {
               rX = x2 + (((float) y) - ((float) y01))/yLimit;
            }
            if (rX > yAngle) {
               rX = yAngle; 
            }
            if (rX < yBorder) {
               rX = yBorder;
            }
            rY = y2 + (((float) x) - ((float) x1))/xLimit;
         }
         if (mButtonDown == true) {
            if (zoom >= zDistance && zoom <= zBorder) {
               zoom = z2 + ((((float) y) - ((float) z1))/zLimit);
            }
            if (zoom < zDistance) {
               zoom = zDistance; 
            }
            if (zoom > zBorder) {
               zoom = zBorder;
            }
         }
     
}

static void 
key2(int key, int x, int y)
{    
        switch (key) 
        {
            case GLUT_KEY_LEFT:
                if (trans1 > -transLimit) {
                    trans1 -= transSpeed;
                 }
                break;
            
            case GLUT_KEY_RIGHT:
                if (trans1 < transLimit) {
                    trans1 += transSpeed;
                 }
                break; 
            
            /*case GLUT_KEY_UP:
                if (trans2 < transLimit) {
                    trans2 += transSpeed;
                 }
                break;
           
            case GLUT_KEY_DOWN:
                if (trans2 > -transLimit) {
                    trans2 -= transSpeed;
                 }
                break;*/
                    
            case GLUT_KEY_F2:
                if (fps == false) {
                    fps = true;
                } else {
                    fps = false;
                }             
                break;
            
            case GLUT_KEY_F3:
                if (wire == false) {
                   wire = true;
                   glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
                   glLineWidth(1.0);
                } else {
                   wire = false;
                   glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
                   glLineWidth(3.0);
                }
                break;
            
            case GLUT_KEY_F4:
                if (light == false) {
                    light = true;
                    glEnable (GL_LIGHTING);
                } else {
                    light = false;
                    glDisable (GL_LIGHTING);
                }             
                break;
        }

    glutPostRedisplay();
}

static void 
key(unsigned char key, int x, int y)
{
    switch (key) 
    {
        case 27:
            exit(0);
            break;
            
        case 'c':
             if (rX <= yAngle - rspeed) {
                rX += rspeed;
             }
             break;
             
        case 'd':
             if (rX >= yBorder + rspeed) {
                rX -= rspeed;
             }
             break;
             
        case 'x':
             rY += rspeed;
             break;
             
        case 's':
             rY -= rspeed;
             break;
             
        case 'a':
             if (zoom >= zDistance + zoomFactor) {
                zoom -= zoomFactor;
             }
             break;
             
        case 'y':
             if (zoom <= zBorder - zoomFactor) {
                zoom += zoomFactor;
             }
             break;
        
        case 'm':
             rX = 90;
             rY = 0;
             zoom = -380;
             trans1 = 0;
             trans2 = 0;
             break;
        
        case 'n':
             if (numberShow == true) {
                numberShow = false;
             } else {
               numberShow = true;
             }             
             break;
        
        case 'b':
             if (portSign == true) {
                portSign = false;
             } else {
               portSign = true;
             }
             break;
    }

    glutPostRedisplay();
}

static void 
idle(void)
{
    const int time = glutGet(GLUT_ELAPSED_TIME);
    srand(time);
    int zufallM;
    int zufallN;
    
    int anzWald = 0;
    int anzBerg = 0;
    int anzWiese = 0;
    int anzWueste = 0;
    int anzFeld = 0;
    int anzLehm = 0;

    int zwei = 0;
    int drei = 0;
    int vier = 0;
    int fuenf = 0;
    int sechs = 0;
    int sieben = 0;
    int acht = 0;
    int neun = 0;
    int zehn = 0;
    int elf = 0;
    int zwoelf = 0;
    
    if (lButtonOneTime == false && lButtonDown == true) {
           lButtonOneTime = true;
           
           if (picked == 312) {
               exit(0);           
           } else if (picked == 309) {
               switch(interfaceToggle) {
                  
                  case false:
                       interfaceToggle = true;
                       interfaceV[6] = interface2;
                       break;
                  
                  case true:
                       interfaceToggle = false;                      
                       interfaceV[6] = deleteObj;
                       break;
               }
           } else if (picked == 364) {
               switch(options) {
                  
                  case false:
                       options = true;
                       interfaceV[71] = interfaceOp;
                       for (int i = 65; i < 71; i++) {
                           interfaceV[i] = interface4;
                       }
                       break;
                  
                  case true:
                       options = false;                      
                       for (int i = 65; i < 72; i++) {
                           interfaceV[i] = deleteObj;
                       }
                       break;
               }
           } else if (picked == 370) {
             if (light == false) {
                light = true;
                glEnable (GL_LIGHTING);
             } else {
                light = false;
                glDisable (GL_LIGHTING);
             }
           } else if (picked == 369) {
             if (fps == false) {
                fps = true;
             } else {
                fps = false;
             }
           } else if (picked == 368) {
             if (wire == false) {
                wire = true;
                glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
                glLineWidth(1.0);
             } else {
                wire = false;
                glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
                glLineWidth(3.0);
             }
           } else if (picked == 367) {
             rX = 90;
             rY = 0;
             zoom = -380;
             trans1 = 0;
             trans2 = 0;
           } else if (picked == 366) {
             if (numberShow == true) {
                numberShow = false;
             } else {
                numberShow = true;
             }
           } else if (picked == 365) {
             if (portSign == true) {
                portSign = false;
             } else {
                portSign = true;
             }
           } else if (wuerfeln == true && picked == 310) {
              
              zufall1 = (rand() % 6) + 1;
              interfaceV[7] = diceV[zufall1-1];
              zufall2 = (rand() % 6) + 1;
              interfaceV[8] = diceV[zufall2-1];
              zufall = zufall1 + zufall2;
              
              for (int i = 0; i < 19; i++) {
                  if (number[i] == zufall) {
                     pointerV[i] = interfaceP;
                  }
              }
              
              for (int i = 0; i < 54; i++) {
                  for (int j = 0; j < 3; j++) {
                      if (houses[i][j] == zufall && k < 12) {
                         dice[k][0] = houses[i][j+3];
                         dice[k][1] = houses[i][6];
                         dice[k][2] = houses[i][7];
                         k++;                         
                      }
                  }
              }
              
              for (int i = 0; i < 12; i++) {
                  switch(dice[i][0]) {
                       
                       case 1:
                            switch(dice[i][1]) {
                                  
                                  case 1:
                                       resources[dice[i][2]][1] += 1;
                                       break;
                                       
                                  case 2:
                                       resources[dice[i][2]][1] += 2;
                                       break;   
                            }
                            break;
                            
                       case 2:
                            switch(dice[i][1]) {
                                  
                                  case 1:
                                       resources[dice[i][2]][2] += 1;
                                       break;
                                       
                                  case 2:
                                       resources[dice[i][2]][2] += 2;
                                       break;   
                            }
                            break;
                       
                       case 3:
                            switch(dice[i][1]) {
                                  
                                  case 1:
                                       resources[dice[i][2]][3] += 1;
                                       break;
                                       
                                  case 2:
                                       resources[dice[i][2]][3] += 2;
                                       break;   
                            }
                            break;
                            
                       case 4:
                            switch(dice[i][1]) {
                                  
                                  case 1:
                                       resources[dice[i][2]][4] += 1;
                                       break;
                                       
                                  case 2:
                                       resources[dice[i][2]][4] += 2;
                                       break;   
                            }
                            break;
                            
                       case 5:
                            switch(dice[i][1]) {
                                  
                                  case 1:
                                       resources[dice[i][2]][5] += 1;
                                       break;
                                       
                                  case 2:
                                       resources[dice[i][2]][5] += 2;
                                       break;   
                            }
                            break;
                  }
              }
              
              for (int i = 0; i < 12; i++) {
                  for (int j = 0; j < 3; j++) {
                      dice[i][j] = 0;
                  }
              }
              k = 0;              
              wuerfeln = false;
              if (kiTurn == 0) {
                 next = true;
              }
                          
           } else if (next == true && trade == false && build == false && picked == 310) {
              tradePlayer = 0;
              tradeItem = 0;
              for(int i = 0; i < 5; i++) {
                  for(int j = 0; j < 2; j++) {
                      tradeArray[i][j] = 0;
                  }
              }
              trade = true;
              tradeModus = true;
              interfaceV[7] = deleteObj;
              interfaceV[8] = deleteObj;
              for (int i = 0; i < 19; i++) {
                  pointerV[i] = deleteObj;
              }
              interfaceV[13] = interface5;
              interfaceV[14] = interface4;              
              interfaceV[15] = tradeV[0];
              interfaceV[16] = tradeV[1];
              interfaceV[17] = tradeV[2];
              interfaceV[18] = tradeV[3];
              interfaceV[19] = tradeV[4];
              interfaceV[20] = tradeV[5];
              interfaceV[21] = tradeV[5];
              interfaceV[22] = tradeV[5];
              interfaceV[23] = tradeV[5];
              interfaceV[24] = tradeV[5];
              interfaceV[25] = tradeV[6];
              interfaceV[26] = tradeV[6];
              interfaceV[27] = tradeV[6];
              interfaceV[28] = tradeV[6];
              interfaceV[29] = tradeV[6];
              
              interfaceV[30] = tradeV[0];
              interfaceV[31] = tradeV[1];
              interfaceV[32] = tradeV[2];
              interfaceV[33] = tradeV[3];
              interfaceV[34] = tradeV[4];              
              
              interfaceV[45] = interface4;
              for (int i = 0; i < playersPicked; i++) {
                  interfaceV[i+46] = interface4;              
              }              
              
           } else if (trade == true && picked == 330) {
              tradeItem = 0;
           
           } else if (trade == true && picked == 331) {
              tradeItem = 1;
           
           } else if (trade == true && picked == 332) {
              tradeItem = 2;
           
           } else if (trade == true && picked == 333) {
              tradeItem = 3;
           
           } else if (trade == true && picked == 334) {
              tradeItem = 4;
           
           } else if (trade == true && picked == 345) {
              tradePlayer = 0;
              tradeItem = 0;
              for(int i = 0; i < 5; i++) {
                  for(int j = 0; j < 2; j++) {
                      tradeArray[i][j] = 0;
                  }
              }
              for(int i = 35; i < 45; i++) {
                    interfaceV[i] = deleteObj;
              }
           
           } else if (trade == true && playerKI[1] == false && player != 1 && picked == 346) {
              tradePlayer = 1;
              for(int i = 0; i < 5; i++) {
                  for(int j = 0; j < 2; j++) {
                      tradeArray[i][j] = 0;
                  }
              }
              interfaceV[35] = tradeV[6];
              interfaceV[36] = tradeV[6];
              interfaceV[37] = tradeV[6];
              interfaceV[38] = tradeV[6];
              interfaceV[39] = tradeV[6];
              interfaceV[40] = tradeV[5];
              interfaceV[41] = tradeV[5];
              interfaceV[42] = tradeV[5];
              interfaceV[43] = tradeV[5];
              interfaceV[44] = tradeV[5];
           
           } else if (trade == true && playerKI[2] == false && player != 2 && picked == 347) {
              tradePlayer = 2;
              for(int i = 0; i < 5; i++) {
                  for(int j = 0; j < 2; j++) {
                      tradeArray[i][j] = 0;
                  }
              }
              interfaceV[35] = tradeV[6];
              interfaceV[36] = tradeV[6];
              interfaceV[37] = tradeV[6];
              interfaceV[38] = tradeV[6];
              interfaceV[39] = tradeV[6];
              interfaceV[40] = tradeV[5];
              interfaceV[41] = tradeV[5];
              interfaceV[42] = tradeV[5];
              interfaceV[43] = tradeV[5];
              interfaceV[44] = tradeV[5];
           
           } else if (trade == true && playerKI[3] == false && player != 3 && picked == 348) {
              tradePlayer = 3;
              for(int i = 0; i < 5; i++) {
                  for(int j = 0; j < 2; j++) {
                      tradeArray[i][j] = 0;
                  }
              }
              interfaceV[35] = tradeV[6];
              interfaceV[36] = tradeV[6];
              interfaceV[37] = tradeV[6];
              interfaceV[38] = tradeV[6];
              interfaceV[39] = tradeV[6];
              interfaceV[40] = tradeV[5];
              interfaceV[41] = tradeV[5];
              interfaceV[42] = tradeV[5];
              interfaceV[43] = tradeV[5];
              interfaceV[44] = tradeV[5];
           
           } else if (trade == true && playerKI[4] == false && player != 4 && picked == 349) {
              tradePlayer = 4;
              for(int i = 0; i < 5; i++) {
                  for(int j = 0; j < 2; j++) {
                      tradeArray[i][j] = 0;
                  }
              }
              interfaceV[35] = tradeV[6];
              interfaceV[36] = tradeV[6];
              interfaceV[37] = tradeV[6];
              interfaceV[38] = tradeV[6];
              interfaceV[39] = tradeV[6];
              interfaceV[40] = tradeV[5];
              interfaceV[41] = tradeV[5];
              interfaceV[42] = tradeV[5];
              interfaceV[43] = tradeV[5];
              interfaceV[44] = tradeV[5];
           
           } else if (trade == true && picked == 314) {
              
              if (tradePlayer != 0) {
                 for(int i = 1; i < 6; i++) {
                      resources[tradePlayer][i] += tradeArray[i-1][0];
                      resources[tradePlayer][i] -= tradeArray[i-1][1];
                 }
              }              
              for(int i = 1; i < 6; i++) {
                      resources[player][i] -= tradeArray[i-1][0];
                      resources[player][i] += tradeArray[i-1][1];
              }
              for(int i = 0; i < 5; i++) {
                  for(int j = 0; j < 2; j++) {
                      tradeArray[i][j] = 0;
                  }
              }
              
           } else if (trade == true && picked == 320) {
              tradePicked1 = 1;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 321) {
              tradePicked1 = 2;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 322) {
              tradePicked1 = 3;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 323) {
              tradePicked1 = 4;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 324) {
              tradePicked1 = 5;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 325) {
              tradePicked1 = 1;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 326) {
              tradePicked1 = 2;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 327) {
              tradePicked1 = 3;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 328) {
              tradePicked1 = 4;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 329) {
              tradePicked1 = 5;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 335) {
              tradePicked2 = 1;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 336) {
              tradePicked2 = 2;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 337) {
              tradePicked2 = 3;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 338) {
              tradePicked2 = 4;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 339) {
              tradePicked2 = 5;
              tradeDelete = false;
              tradeCheck = true;
           
           } else if (trade == true && picked == 340) {
              tradePicked2 = 1;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 341) {
              tradePicked2 = 2;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 342) {
              tradePicked2 = 3;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 343) {
              tradePicked2 = 4;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && picked == 344) {
              tradePicked2 = 5;
              tradeDelete = true;
              tradeCheck = true;
           
           } else if (trade == true && build == false && picked == 310) {
              for(int i = 13; i < 50; i++) {
                      interfaceV[i] = deleteObj;
              }
              trade = false;
              build = true;
              redraw = true;
              buildFT = true;              
                 
           } else if (next == true && picked == 311) {
             interfaceV[7] = deleteObj;
             interfaceV[8] = deleteObj;
             for (int i = 0; i < 19; i++) {
                 pointerV[i] = deleteObj;
             }
             for(int i = 13; i < 50; i++) {
                 interfaceV[i] = deleteObj;
             }             
             
             if (resources[player][0] >= winPoints) {
                win = true;
                next = false;
                trade = false;
                build = false;
                numberShow = false;
                portSign = false;
                redraw = true;
             } else {
                 if (player < playersPicked) {
                   player++;
                 } else {
                   player = 1;
                   runde++;
                 }
                 //pointerV[19] = playerV[player-1];
                 next = false;
                 trade = false;
                 build = false;
                 redraw = true;
                 
                 if (playerKI[player] == true) {
                   kiTurn = 1;
                 } else {
                   wuerfeln = true;
                 }
             }
           
           } else if (playersChoice == true && picked == 352) {
              playersPicked = 1;
           } else if (playersChoice == true && picked == 353) {
              playersPicked = 2;
           } else if (playersChoice == true && picked == 354) {
              playersPicked = 3;
           } else if (playersChoice == true && picked == 355) {
              playersPicked = 4;
           } else if (playersChoice == true && picked == 356) {
              playerKI[1] = false;
           } else if (playersChoice == true && picked == 357 && playersPicked > 1) {
              playerKI[2] = false;
           } else if (playersChoice == true && picked == 358 && playersPicked > 2) {
              playerKI[3] = false;
           } else if (playersChoice == true && picked == 359 && playersPicked > 3) {
              playerKI[4] = false;
           } else if (playersChoice == true && picked == 360) {
              playerKI[1] = true;
           } else if (playersChoice == true && picked == 361 && playersPicked > 1) {
              playerKI[2] = true;
           } else if (playersChoice == true && picked == 362 && playersPicked > 2) {
              playerKI[3] = true;
           } else if (playersChoice == true && picked == 363 && playersPicked > 3) {
              playerKI[4] = true;
           } else if (playersChoice == true && picked == 351) {
               
              for(int i = 50; i < 64; i++) {
                 interfaceV[i] = deleteObj;
              }
              for (int i = 0; i < 19; i++) {  
                 
                 zufallM = (rand() % 6);
                 switch(zufallM) {
                 
                       case 0:
                            if (anzWald < 4) {
                               model[i] = 1;
                               anzWald++;
                            } else {
                                 i--;  
                            }
                            break;
                            
                       case 1:
                            if (anzWiese < 4) {
                                model[i] = 2;
                                anzWiese++;
                            } else {
                                 i--;  
                            }
                            break;
                       
                       case 2:
                            if (anzFeld < 4) {
                                model[i] = 3;
                                anzFeld++;
                            } else {
                                  i--; 
                            }
                            break;
                            
                       case 3:
                            if (anzBerg < 3) {
                                model[i] = 4;
                                anzBerg++;
                            } else {
                                  i--; 
                            }
                            break;
                            
                       case 4:
                            if (anzLehm < 3) {
                                model[i] = 5;
                                anzLehm++;
                            } else {
                                 i--;  
                            }
                            break;
                       
                       case 5:
                            if (anzWueste < 1) {
                                model[i] = 6;
                                anzWueste++;
                            } else {
                                 i--;  
                            }
                            break;         
                 }
              }
                 
              for (int i = 0; i < 19; i++) {
                     
                     zufallN = (rand() % 11);
                     switch(zufallN) {
                            
                            case 0:
                                 if (zwei < 1) {
                                    number[i] = 2;
                                    zwei++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 1:
                                 if (drei < 2) {
                                    number[i] = 3;
                                    drei++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 2:
                                 if (vier < 2) {
                                    number[i] = 4;
                                    vier++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 3:
                                 if (fuenf < 2) {
                                    number[i] = 5;
                                    fuenf++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 4:
                                 if (sechs < 2) {
                                    number[i] = 6;
                                    sechs++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 5:
                                 if (sieben < 1) {
                                    number[i] = 7;
                                    sieben++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 6:
                                 if (acht < 2) {
                                    number[i] = 8;
                                    acht++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 7:
                                 if (neun < 2) {
                                    number[i] = 9;
                                    neun++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 8:
                                 if (zehn < 2) {
                                    number[i] = 10;
                                    zehn++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 9:
                                 if (elf < 2) {
                                    number[i] = 11;
                                    elf++;
                                 } else {
                                   i--;  
                                 }
                                 break;
                                 
                            case 10:
                                 if (zwoelf < 1) {
                                    number[i] = 12;
                                    zwoelf++;
                                 } else {
                                   i--;  
                                 }
                                 break;                             
                     }                 
              }          
              houses[0][0] = number[18];
              houses[1][0] = number[18];
              houses[2][0] = number[18];
              houses[2][1] = number[7];
              houses[3][0] = number[7];
              houses[4][0] = number[7];
              houses[4][1] = number[8];
              houses[5][0] = number[8];
              houses[6][0] = number[8];
              houses[7][0] = number[17];
              houses[8][0] = number[17];
              houses[8][1] = number[18];
              houses[9][0] = number[17];
              houses[9][1] = number[18];
              houses[9][2] = number[6];             
              houses[10][0] = number[18];
              houses[10][1] = number[6];
              houses[10][2] = number[7];
              houses[11][0] = number[6];
              houses[11][1] = number[7];
              houses[11][2] = number[1];
              houses[12][0] = number[7];
              houses[12][1] = number[1];
              houses[12][2] = number[8];
              houses[13][0] = number[1];
              houses[13][1] = number[8];
              houses[13][2] = number[9];
              houses[14][0] = number[8];
              houses[14][1] = number[9];
              houses[15][0] = number[9];             
              houses[16][0] = number[16];
              houses[17][0] = number[16];
              houses[17][1] = number[17];
              houses[18][0] = number[16];
              houses[18][1] = number[17];
              houses[18][2] = number[5];
              houses[19][0] = number[17];
              houses[19][1] = number[5];
              houses[19][2] = number[6];
              houses[20][0] = number[5];
              houses[20][1] = number[6];
              houses[20][2] = number[0];
              houses[21][0] = number[6];
              houses[21][1] = number[0];
              houses[21][2] = number[1];             
              houses[22][0] = number[0];
              houses[22][1] = number[1];
              houses[22][2] = number[2];
              houses[23][0] = number[1];
              houses[23][1] = number[2];
              houses[23][2] = number[9];
              houses[24][0] = number[2];
              houses[24][1] = number[9];
              houses[24][2] = number[10];
              houses[25][0] = number[9];
              houses[25][1] = number[10];
              houses[26][0] = number[10];
              houses[27][0] = number[16];
              houses[28][0] = number[16];
              houses[28][1] = number[15];             
              houses[29][0] = number[16];
              houses[29][1] = number[15];
              houses[29][2] = number[5];
              houses[30][0] = number[15];
              houses[30][1] = number[5];
              houses[30][2] = number[4];
              houses[31][0] = number[5];
              houses[31][1] = number[4];
              houses[31][2] = number[0];
              houses[32][0] = number[4];
              houses[32][1] = number[0];
              houses[32][2] = number[3];
              houses[33][0] = number[0];
              houses[33][1] = number[3];
              houses[33][2] = number[2];             
              houses[34][0] = number[3];
              houses[34][1] = number[2];
              houses[34][2] = number[11];
              houses[35][0] = number[2];
              houses[35][1] = number[11];
              houses[35][2] = number[10];
              houses[36][0] = number[11];
              houses[36][1] = number[10];
              houses[37][0] = number[10];
              houses[38][0] = number[15];
              houses[39][0] = number[15];
              houses[39][1] = number[14];
              houses[40][0] = number[15];
              houses[40][1] = number[14];
              houses[40][2] = number[4];             
              houses[41][0] = number[14];
              houses[41][1] = number[4];
              houses[41][2] = number[13];
              houses[42][0] = number[4];
              houses[42][1] = number[13];
              houses[42][2] = number[3];
              houses[43][0] = number[13];
              houses[43][1] = number[3];
              houses[43][2] = number[12];
              houses[44][0] = number[3];
              houses[44][1] = number[12];
              houses[44][2] = number[11];
              houses[45][0] = number[12];
              houses[45][1] = number[11];
              houses[46][0] = number[11];             
              houses[47][0] = number[14];
              houses[48][0] = number[14];
              houses[49][0] = number[14];
              houses[49][1] = number[13];
              houses[50][0] = number[13];
              houses[51][0] = number[13];
              houses[51][1] = number[12];
              houses[52][0] = number[12];
              houses[53][0] = number[12];
              
              houses[0][3] = model[18];
              houses[1][3] = model[18];
              houses[2][3] = model[18];
              houses[2][4] = model[7];
              houses[3][3] = model[7];
              houses[4][3] = model[7];
              houses[4][4] = model[8];
              houses[5][3] = model[8];
              houses[6][3] = model[8];
              houses[7][3] = model[17];
              houses[8][3] = model[17];
              houses[8][4] = model[18];
              houses[9][3] = model[17];
              houses[9][4] = model[18];
              houses[9][5] = model[6];             
              houses[10][3] = model[18];
              houses[10][4] = model[6];
              houses[10][5] = model[7];
              houses[11][3] = model[6];
              houses[11][4] = model[7];
              houses[11][5] = model[1];
              houses[12][3] = model[7];
              houses[12][4] = model[1];
              houses[12][5] = model[8];
              houses[13][3] = model[1];
              houses[13][4] = model[8];
              houses[13][5] = model[9];
              houses[14][3] = model[8];
              houses[14][4] = model[9];
              houses[15][3] = model[9];             
              houses[16][3] = model[16];
              houses[17][3] = model[16];
              houses[17][4] = model[17];
              houses[18][3] = model[16];
              houses[18][4] = model[17];
              houses[18][5] = model[5];
              houses[19][3] = model[17];
              houses[19][4] = model[5];
              houses[19][5] = model[6];
              houses[20][3] = model[5];
              houses[20][4] = model[6];
              houses[20][5] = model[0];
              houses[21][3] = model[6];
              houses[21][4] = model[0];
              houses[21][5] = model[1];             
              houses[22][3] = model[0];
              houses[22][4] = model[1];
              houses[22][5] = model[2];
              houses[23][3] = model[1];
              houses[23][4] = model[2];
              houses[23][5] = model[9];
              houses[24][3] = model[2];
              houses[24][4] = model[9];
              houses[24][5] = model[10];
              houses[25][3] = model[9];
              houses[25][4] = model[10];
              houses[26][3] = model[10];
              houses[27][3] = model[16];
              houses[28][3] = model[16];
              houses[28][4] = model[15];             
              houses[29][3] = model[16];
              houses[29][4] = model[15];
              houses[29][5] = model[5];
              houses[30][3] = model[15];
              houses[30][4] = model[5];
              houses[30][5] = model[4];
              houses[31][3] = model[5];
              houses[31][4] = model[4];
              houses[31][5] = model[0];
              houses[32][3] = model[4];
              houses[32][4] = model[0];
              houses[32][5] = model[3];
              houses[33][3] = model[0];
              houses[33][4] = model[3];
              houses[33][5] = model[2];             
              houses[34][3] = model[3];
              houses[34][4] = model[2];
              houses[34][5] = model[11];
              houses[35][3] = model[2];
              houses[35][4] = model[11];
              houses[35][5] = model[10];
              houses[36][3] = model[11];
              houses[36][4] = model[10];
              houses[37][3] = model[10];
              houses[38][3] = model[15];
              houses[39][3] = model[15];
              houses[39][4] = model[14];
              houses[40][3] = model[15];
              houses[40][4] = model[14];
              houses[40][5] = model[4];             
              houses[41][3] = model[14];
              houses[41][4] = model[4];
              houses[41][5] = model[13];
              houses[42][3] = model[4];
              houses[42][4] = model[13];
              houses[42][5] = model[3];
              houses[43][3] = model[13];
              houses[43][4] = model[3];
              houses[43][5] = model[12];
              houses[44][3] = model[3];
              houses[44][4] = model[12];
              houses[44][5] = model[11];
              houses[45][3] = model[12];
              houses[45][4] = model[11];
              houses[46][3] = model[11];             
              houses[47][3] = model[14];
              houses[48][3] = model[14];
              houses[49][3] = model[14];
              houses[49][4] = model[13];
              houses[50][3] = model[13];
              houses[51][3] = model[13];
              houses[51][4] = model[12];
              houses[52][3] = model[12];
              houses[53][3] = model[12];
              
              for (int i = 0; i < 19; i++) {
                  switch(model[i]) {
                      
                      case 1:
                           modelV[i] = objectF1;
                           break;
                      
                      case 2:
                           modelV[i] = objectF2;
                           break;
                      
                      case 3:
                           modelV[i] = objectF3;
                           break;
                      
                      case 4:
                           modelV[i] = objectF4;
                           break;
                      
                      case 5:
                           modelV[i] = objectF5;
                           break;
                      
                      case 6:
                           modelV[i] = objectF6;
                           break;
                  }
              }
              for (int i = 19; i < 28; i++) {
                  modelV[i] = objectF7;
              }
              modelV[28] = objectF0;
              
              player = 1;
              if (playerKI[player] == true) {
                 kiTurn = 1;
              }
              //pointerV[19] = playerV[player-1];
              playersChoice = false;
              build = true;
              redraw = true;
              buildFT = true;
           }           
           if (build == true) {
              if (picked >= 100 && picked < 154) {
                    switch(houses[picked-100][6]) {
                          
                          case 0:
                               if (houses[availableCheck1[picked-100][0]][6] == 0 && houses[availableCheck1[picked-100][1]][6] == 0 && (availableCheck1[picked-100][2] < 0 || houses[availableCheck1[picked-100][2]][6] == 0)) {
                                     if (firstTime < (playersPicked * 4)) {
                                            if ((firstTime % 2) == 0) {
                                               houses[picked-100][7] = player;
                                               houses[picked-100][6] = 1;
                                               resources[player][0] += 1;                                                        
                                               firstTime++;
                                               redraw = true;
                                               buildFT = true;
                                            }
                                     } else if ((streets[availableCheck1[picked-100][3]] == player || streets[availableCheck1[picked-100][4]] == player || (availableCheck1[picked-100][5] >= 0 && streets[availableCheck1[picked-100][5]] == player)) && resources[player][1] >= 1 && resources[player][2] >= 1 && resources[player][3] >= 1 && resources[player][5] >= 1) {
                                           houses[picked-100][7] = player;
                                           houses[picked-100][6] = 1;
                                           resources[player][0] += 1;
                                           resources[player][1] -= 1;
                                           resources[player][2] -= 1;
                                           resources[player][3] -= 1;
                                           resources[player][5] -= 1;
                                           redraw = true;
                                           buildFT = true;
                                     }
                               }
                               break;
                          
                          case 1:
                               if (houses[picked-100][7] == player && resources[player][3] >=2 && resources[player][4] >= 3) {
                                     houses[picked-100][6] = 2;
                                     resources[player][0] += 1;
                                     resources[player][3] -= 2;
                                     resources[player][4] -= 3;
                                     redraw = true;
                                     buildFT = true;
                               }
                               break;
                    }
              }
              if (picked >= 200 && picked < 272) {
                     if (streets[picked-200] == 0) {
                           if (firstTime < (playersPicked * 4) && ((houses[availableCheck2[picked-200][0]][7] == player && streets[availableCheck2[picked-200][2]] == 0 && streets[availableCheck2[picked-200][3]] == 0) || (houses[availableCheck2[picked-200][1]][7] == player && streets[availableCheck2[picked-200][4]] == 0 && streets[availableCheck2[picked-200][5]] == 0))) {
                                if ((firstTime % 2) == 1) {
                                   streets[picked-200] = player;
                                   firstTime++;
                                   redraw = true;
                                   buildFT = true;
                                   playerCheck = true;
                                }
                           } else if ((houses[availableCheck2[picked-200][0]][7] == player || houses[availableCheck2[picked-200][1]][7] == player || streets[availableCheck2[picked-200][2]] == player || streets[availableCheck2[picked-200][3]] == player || streets[availableCheck2[picked-200][4]] == player || streets[availableCheck2[picked-200][5]] == player) && resources[player][1] >= 1 && resources[player][5] >= 1) {
                                  streets[picked-200] = player;
                                  resources[player][1] -= 1;
                                  resources[player][5] -= 1;
                                  redraw = true;
                                  buildFT = true;
                           }
                     }
              }
           }
           
    }
    
    if (fps == true) {
       frames++;
       if ((time - frameTime) >= 500) {
         float seconds = ((float)time - (float)frameTime) / 1000;
         frameRate = frames / seconds;
         frameTime = time;
         frames = 0;
       }
    }
    
    if (waveCount <= time) {
		for(int y = 0; y < 2; y++ )
		{
			hold=water[0][y][2];
			for(int x = 0; x < 719; x++)
			{
				water[x][y][2] = water[x+1][y][2];
			}
			water[719][y][2]=hold;
		}
		waveCount += 40;
	}
	
    if(tradeModus == true) {
       tradeModus = false;
       for(int i = 0; i < 5; i++) {                
               tradeStep[i] = 4;
       }
                  
       if (houses[0][7] == player || houses[1][7] == player || houses[14][7] == player || houses[15][7] == player || houses[26][7] == player || houses[37][7] == player || houses[47][7] == player || houses[48][7] == player) {
          for(int i = 0; i < 5; i++) {                
                  tradeStep[i] = 3;
          }
       }
       if (houses[3][7] == player || houses[4][7] == player) {
          tradeStep[1] = 2;
       }
       if (houses[45][7] == player || houses[46][7] == player) {
          tradeStep[4] = 2;
       }
       if (houses[50][7] == player || houses[51][7] == player) {
          tradeStep[0] = 2;
       }
       if (houses[28][7] == player || houses[38][7] == player) {
          tradeStep[2] = 2;
       }
       if (houses[7][7] == player || houses[17][7] == player) {
          tradeStep[3] = 2;
       }
    }
    
    if(tradeCheck == true) {
       tradeCheck = false;
       
       if (tradePlayer == 0) {
           if (tradeDelete == false && (resources[player][tradeItem+1] >= (tradeArray[tradeItem][0] + tradeStep[tradeItem]))) {
              tradeArray[tradeItem][0] += tradeStep[tradeItem];
              tradeArray[tradePicked1-1][1] += 1;
           } else if (tradeDelete == true && (tradeArray[tradeItem][0] >= tradeStep[tradeItem])) {
              tradeArray[tradeItem][0] -= tradeStep[tradeItem];
              tradeArray[tradePicked1-1][1] -= 1;
           }
       } else if (tradePicked1 != 0) {
           if (tradeDelete == false && (resources[tradePlayer][tradePicked1] > tradeArray[tradePicked1-1][1])) {
              tradeArray[tradePicked1-1][1] += 1;
           } else if (tradeDelete == true && tradeArray[tradePicked1-1][1] > 0) {
              tradeArray[tradePicked1-1][1] -= 1;
           }
       } else if (tradePicked2 != 0) {
           if (tradeDelete == false && (resources[player][tradePicked2] > tradeArray[tradePicked2-1][0])) {
              tradeArray[tradePicked2-1][0] += 1;
           } else if (tradeDelete == true && tradeArray[tradePicked2-1][0] > 0) {
              tradeArray[tradePicked2-1][0] -= 1;
           }
       }
       tradePicked1 = 0;
       tradePicked2 = 0;
    }
    
    if (kiTurn > 0) {
       if (firstTime <= (playersPicked * 4)) {
           switch(kiTurn) {
                 case 1:
                      kiTime = time;
                      kiTurn++;
                      break;
                 
                 case 2:                         
                      if (time >= (kiTime + kiWait1)) {
                          for (int i = 0; i < 54; i++) {
                              if (housesV[i].id_texture == buildV[player][1].id_texture) {
                                  for (int j = 3; j < 6; j++) {
                                      switch(houses[i][j]) {
                                            
                                            case 1:
                                                 posPoints1 += 6;
                                                 break;
                                            
                                            case 2:
                                                 posPoints1 += 3;
                                                 break;
                                            
                                            case 3:
                                                 posPoints1 += 4;
                                                 break;
                                            
                                            case 4:
                                                 posPoints1 += 5;
                                                 break;
                                            
                                            case 5:
                                                 posPoints1 += 6;
                                                 break;
                                            
                                            case 6:
                                                 switch(houses[i][j-3]) {
                                                       
                                                        case 2:
                                                             posPoints2 -= 2;
                                                             break;
                                                        
                                                        case 3:
                                                             posPoints2 -= 3;
                                                             break;
                                                        
                                                        case 4:
                                                             posPoints2 -= 4;
                                                             break;
                                                        
                                                        case 5:
                                                             posPoints2 -= 5;
                                                             break;
                                                        
                                                        case 6:
                                                             posPoints2 -= 6;
                                                             break;
                                                        
                                                        case 7:
                                                             posPoints2 -= 7;
                                                             break;
                                                        
                                                        case 8:
                                                             posPoints2 -= 6;
                                                             break;
                                                        
                                                        case 9:
                                                             posPoints2 -= 5;
                                                             break;
                                                        
                                                        case 10:
                                                             posPoints2 -= 4;
                                                             break;
                                                        
                                                        case 11:
                                                             posPoints2 -= 3;
                                                             break;
                                                        
                                                        case 12:
                                                             posPoints2 -= 2;
                                                             break;
                                                 }
                                                 break;
                                      }
                                  }
                                  for (int j = 0; j < 3; j++) {
                                      switch(houses[i][j]) {
                                            
                                            case 2:
                                                 posPoints2 += 2;
                                                 break;
                                            
                                            case 3:
                                                 posPoints2 += 3;
                                                 break;
                                            
                                            case 4:
                                                 posPoints2 += 4;
                                                 break;
                                            
                                            case 5:
                                                 posPoints2 += 5;
                                                 break;
                                            
                                            case 6:
                                                 posPoints2 += 6;
                                                 break;
                                            
                                            case 7:
                                                 posPoints2 += 7;
                                                 break;
                                            
                                            case 8:
                                                 posPoints2 += 6;
                                                 break;
                                            
                                            case 9:
                                                 posPoints2 += 5;
                                                 break;
                                            
                                            case 10:
                                                 posPoints2 += 4;
                                                 break;
                                            
                                            case 11:
                                                 posPoints2 += 3;
                                                 break;
                                            
                                            case 12:
                                                 posPoints2 += 2;
                                                 break;
                                      }
                                  }
                                  posPoints = posPoints1 * posPoints2;
                                  if (posPoints > posPointsTop) {
                                     posPointsTop = posPoints;
                                     picked = 100 + i;
                                     lButtonDown = true;
                                     lButtonOneTime = false;
                                     player3too1[0] = false;
                                     if (player3too1[0] == false && (i == 0 || i == 1 || i == 14 || i == 15 || i == 26 || i == 37 || i == 47 || i == 48)) {
                                        player3too1[0] = true;
                                     }
                                  }
                                  posPoints1 = 0;
                                  posPoints2 = 0;
                              }
                          }
                          if (player3too1[0] == true) {
                             player3too1[0] = false;
                             player3too1[player] = true;
                          }
                          posPointsTop = 0;
                          kiTime = time;
                          kiTurn++;
                      }
                      break;
                 
                 case 3:
                      if (time >= (kiTime + kiWait1)) {
                          for (int i = 0;  i < 54; i++) {
                              if (houses[i][7] == player) {
                                  for (int h = 0; h < 18; h++) {
                                      if (streetsV[buildCheck[i][h][1]].id_texture == buildV[player][0].id_texture && buildCheck[i][h][0] >= 0 && houses[buildCheck[i][h][0]][6] == 0 && houses[availableCheck1[buildCheck[i][h][0]][0]][6] == 0 && houses[availableCheck1[buildCheck[i][h][0]][1]][6] == 0 && houses[availableCheck1[buildCheck[i][h][0]][2]][6] == 0 &&
                                         (streets[buildCheck[i][h][1]] == player || streets[buildCheck[i][h][1]] == 0) && (streets[buildCheck[i][h][2]] == player || streets[buildCheck[i][h][2]] == 0) && (buildCheck[i][h][3] < 0 || streets[buildCheck[i][h][3]] == player || streets[buildCheck[i][h][3]] == 0)) {
                                          for (int j = 3; j < 6; j++) {
                                              switch(houses[buildCheck[i][h][0]][j]) {
                                                    
                                                    case 1:
                                                         posPoints1 += 6;
                                                         break;
                                                    
                                                    case 2:
                                                         posPoints1 += 3;
                                                         break;
                                                    
                                                    case 3:
                                                         posPoints1 += 4;
                                                         break;
                                                    
                                                    case 4:
                                                         posPoints1 += 5;
                                                         break;
                                                    
                                                    case 5:
                                                         posPoints1 += 6;
                                                         break;
                                                    
                                                    case 6:
                                                         switch(houses[i][j-3]) {
                                                               
                                                                case 2:
                                                                     posPoints2 -= 2;
                                                                     break;
                                                                
                                                                case 3:
                                                                     posPoints2 -= 3;
                                                                     break;
                                                                
                                                                case 4:
                                                                     posPoints2 -= 4;
                                                                     break;
                                                                
                                                                case 5:
                                                                     posPoints2 -= 5;
                                                                     break;
                                                                
                                                                case 6:
                                                                     posPoints2 -= 6;
                                                                     break;
                                                                
                                                                case 7:
                                                                     posPoints2 -= 7;
                                                                     break;
                                                                
                                                                case 8:
                                                                     posPoints2 -= 6;
                                                                     break;
                                                                
                                                                case 9:
                                                                     posPoints2 -= 5;
                                                                     break;
                                                                
                                                                case 10:
                                                                     posPoints2 -= 4;
                                                                     break;
                                                                
                                                                case 11:
                                                                     posPoints2 -= 3;
                                                                     break;
                                                                
                                                                case 12:
                                                                     posPoints2 -= 2;
                                                                     break;
                                                         }
                                                         break;
                                              }
                                          }
                                          for (int j = 0; j < 3; j++) {
                                              switch(houses[buildCheck[i][h][0]][j]) {
                                                    
                                                    case 2:
                                                         posPoints2 += 2;
                                                         break;
                                                    
                                                    case 3:
                                                         posPoints2 += 3;
                                                         break;
                                                    
                                                    case 4:
                                                         posPoints2 += 4;
                                                         break;
                                                    
                                                    case 5:
                                                         posPoints2 += 5;
                                                         break;
                                                    
                                                    case 6:
                                                         posPoints2 += 6;
                                                         break;
                                                    
                                                    case 7:
                                                         posPoints2 += 7;
                                                         break;
                                                    
                                                    case 8:
                                                         posPoints2 += 6;
                                                         break;
                                                    
                                                    case 9:
                                                         posPoints2 += 5;
                                                         break;
                                                    
                                                    case 10:
                                                         posPoints2 += 4;
                                                         break;
                                                    
                                                    case 11:
                                                         posPoints2 += 3;
                                                         break;
                                                    
                                                    case 12:
                                                         posPoints2 += 2;
                                                         break;
                                              }
                                          }
                                          if (buildCheck[i][h][3] < 0) {
                                             posPoints = (posPoints1 * posPoints2) * 2;
                                          } else {
                                             posPoints = posPoints1 * posPoints2;
                                          }
                                          if (player3too1[player] == false && (buildCheck[i][h][0] == 0 || buildCheck[i][h][0] == 1 || buildCheck[i][h][0] == 14 || buildCheck[i][h][0] == 15 || buildCheck[i][h][0] == 26 || buildCheck[i][h][0] == 37 || buildCheck[i][h][0] == 47 || buildCheck[i][h][0] == 48)) {
                                             posPoints += 300;
                                          } else if (buildCheck[i][h][0] == 3 || buildCheck[i][h][0] == 4 || buildCheck[i][h][0] == 45 || buildCheck[i][h][0] == 46 || buildCheck[i][h][0] == 50 || buildCheck[i][h][0] == 51 || buildCheck[i][h][0] == 28 || buildCheck[i][h][0] == 38 || buildCheck[i][h][0] == 7 || buildCheck[i][h][0] == 17) {
                                             posPoints += 150;
                                          }
                                          if (posPoints > posPointsTop) {
                                             posPointsTop = posPoints;
                                             if (streets[buildCheck[i][h][1]] == 0) {
                                                picked = 200 + buildCheck[i][h][1];
                                                lButtonOneTime = false;
                                             } else if (streets[buildCheck[i][h][2]] == 0) {
                                                picked = 200 + buildCheck[i][h][2];
                                                lButtonOneTime = false;
                                             } else if (buildCheck[i][h][3] >= 0 && streets[buildCheck[i][h][3]] == 0) {
                                                picked = 200 + buildCheck[i][h][3];
                                                lButtonOneTime = false;
                                             } else {
                                                buildHouse[player][0] = false;
                                                buildHouse[player][1] = true;
                                                lButtonOneTime = true;
                                             }
                                          }
                                          posPoints1 = 0;
                                          posPoints2 = 0;
                                      }
                                  }
                              }
                          }
                          posPointsTop = 0;
                          kiTurn++;
                      }
                      break;
                
                 case 4:
                      kiTurn = 0;
                      lButtonDown = false;
                      lButtonOneTime = false;
                      break;
           }                     
       } else {
          switch(kiTurn) {
              
              case 1:
                   kiTime = time;
                   kiTurn++;
                   break;
              
              case 2:
                   if (time >= (kiTime + kiWait1)) {
                      lButtonDown = true;
                      lButtonOneTime = false;
                      wuerfeln = true;
                      picked = 310;
                      kiTime = time;
                      kiTurn = 3;
                      tradeModus = true;
                   }
                   break;
              
              case 3:
                   if (time >= (kiTime + kiWait2)) {
                      if (kiTrade == false && (resources[player][1] > tradeStep[0] || resources[player][2] > tradeStep[1] || resources[player][3] > tradeStep[2] || resources[player][4] >= (tradeStep[3] + 3) || resources[player][5] > tradeStep[4])) {
                         next = true;
                         trade = false;
                         build = false;
                         picked = 310;
                         lButtonOneTime = false;
                         kiTurn++;
                      } else if ((buildHouse[player][0] == true && resources[player][1] >= 1 && resources[player][5] >= 1) ||
                                (buildHouse[player][1] == true && resources[player][1] >= 1 && resources[player][2] >= 1 && resources[player][3] >= 1 && resources[player][5] >= 1) ||
                                (buildHouse[player][2] == true && resources[player][3] >= 2 && resources[player][4] >= 3)) {
                         trade = true;
                         build = false;
                         picked = 310;
                         lButtonOneTime = false;
                         kiTurn = 5;
                      } else {
                         kiTurn = 9;
                      }
                      kiTrade = false;
                      kiTime = time;
                   }
                   break;
              
              case 4:
                   if (time >= (kiTime + kiWait1)) {
                      picked = -1;
                      if (resources[player][2] > tradeStep[1] && resources[player][2] > (tradeArray[1][0] + tradeStep[1])) {
                         if (buildHouse[player][2] == true && resources[player][3] >= 1 && resources[player][4] >= 2) {
                             if ((resources[player][3] + tradeArray[2][1]) < 2) {
                                picked = 327;
                             } else if ((resources[player][4] + tradeArray[3][1]) < 3) {
                                picked = 328;
                             }
                         } else {
                             if ((resources[player][1] + tradeArray[0][1]) == 0) {
                                picked = 325;
                             } else if ((resources[player][5] + tradeArray[4][1]) == 0) {
                                picked = 329;
                             } else if ((resources[player][3] + tradeArray[2][1]) == 0) {
                                picked = 327;
                             }
                         }
                         tradeItem = 1;
                         lButtonOneTime = false;
                      } else if (resources[player][4] >= (tradeStep[3] + 3) && resources[player][4] >= (tradeArray[3][0] + tradeStep[3] + 3)) {
                         if (buildHouse[player][2] == true && resources[player][3] >= 1) {
                             if ((resources[player][3] + tradeArray[2][1]) < 2) {
                                picked = 327;
                             }
                         } else {
                             if ((resources[player][1] + tradeArray[0][1]) == 0) {
                                picked = 325;
                             } else if ((resources[player][5] + tradeArray[4][1]) == 0) {
                                picked = 329;
                             } else if ((resources[player][3] + tradeArray[2][1]) == 0) {
                                picked = 327;
                             } else if ((resources[player][2] + tradeArray[1][1]) == 0) {
                                picked = 326;
                             }
                         }
                         tradeItem = 3;
                         lButtonOneTime = false;
                      } else if (resources[player][3] >= (tradeStep[2] + 2) && resources[player][3] >= (tradeArray[2][0] + tradeStep[2] + 2)) {
                         if (buildHouse[player][2] == true && resources[player][4] >= 2) {
                             if ((resources[player][4] + tradeArray[3][1]) < 3) {
                                picked = 328;
                             }
                         } else {
                             if ((resources[player][1] + tradeArray[0][1]) == 0) {
                                picked = 325;
                             } else if ((resources[player][5] + tradeArray[4][1]) == 0) {
                                picked = 329;
                             } else if ((resources[player][2] + tradeArray[1][1]) == 0) {
                                picked = 326;
                             }
                         }
                         tradeItem = 2;
                         lButtonOneTime = false;
                      } else if (resources[player][1] > tradeStep[0] && resources[player][1] > (tradeArray[0][0] + tradeStep[0])) {
                         if (buildHouse[player][2] == true && resources[player][3] >= 1 && resources[player][4] >= 2) {
                             if ((resources[player][3] + tradeArray[2][1]) < 2) {
                                picked = 327;
                             } else if ((resources[player][4] + tradeArray[3][1]) < 3) {
                                picked = 328;
                             }
                         } else {
                             if ((resources[player][5] + tradeArray[4][1]) == 0) {
                                picked = 329;
                             } else if ((resources[player][3] + tradeArray[2][1]) == 0) {
                                picked = 327;
                             } else if ((resources[player][2] + tradeArray[1][1]) == 0) {
                                picked = 326;
                             }
                         }
                         tradeItem = 0;
                         lButtonOneTime = false;
                      } else if (resources[player][5] > tradeStep[4] && resources[player][5] > (tradeArray[4][0] + tradeStep[4])) {
                         if (buildHouse[player][2] == true && resources[player][3] >= 1 && resources[player][4] >= 2) {
                             if ((resources[player][3] + tradeArray[2][1]) < 2) {
                                picked = 327;
                             } else if ((resources[player][4] + tradeArray[3][1]) < 3) {
                                picked = 328;
                             }
                         } else {
                             if ((resources[player][1] + tradeArray[0][1]) == 0) {
                                picked = 325;
                             } else if ((resources[player][3] + tradeArray[2][1]) == 0) {
                                picked = 327;
                             } else if ((resources[player][2] + tradeArray[1][1]) == 0) {
                                picked = 326;
                             }
                         }
                         tradeItem = 4;
                         lButtonOneTime = false;
                      }
                      if (picked < 0) {
                         kiTrade = true;
                         picked = 314;
                         lButtonOneTime = false;
                         kiTurn = 3;
                      }
                      kiTime = time;
                   }
                   break;
              
              case 5:
                   if (time >= (kiTime + kiWait1)) {
                      if (buildHouse[player][0] == true && resources[player][1] >= 1 && resources[player][5] >= 1) {
                         buildHouse[player][0] = false;
                         kiTurn = 6;
                      } else if (buildHouse[player][1] == true && resources[player][1] >= 1 && resources[player][2] >= 1 && resources[player][3] >= 1 && resources[player][5] >= 1) {
                         kiTurn = 7;
                      } else if (buildHouse[player][2] == true && resources[player][3] >= 2 && resources[player][4] >= 3) {
                         buildHouse[player][2] = false;
                         kiTurn = 8;
                      } else {
                         kiTurn = 9;
                      }
                      kiTime = time;
                   }
                   break;
              
              case 6:
                   if (time >= (kiTime + kiWait1)) {
                      for (int i = 0;  i < 54; i++) {
                          if (houses[i][7] == player) {
                              for (int h = 0; h < 18; h++) {
                                  if (buildCheck[i][h][0] >= 0 && houses[buildCheck[i][h][0]][6] == 0 && houses[availableCheck1[buildCheck[i][h][0]][0]][6] == 0 && houses[availableCheck1[buildCheck[i][h][0]][1]][6] == 0 && houses[availableCheck1[buildCheck[i][h][0]][2]][6] == 0 &&
                                     (streets[buildCheck[i][h][1]] == player || streets[buildCheck[i][h][1]] == 0) && (streets[buildCheck[i][h][2]] == player || streets[buildCheck[i][h][2]] == 0) && (buildCheck[i][h][3] < 0 || streets[buildCheck[i][h][3]] == player || streets[buildCheck[i][h][3]] == 0)) {
                                      for (int j = 3; j < 6; j++) {
                                          switch(houses[buildCheck[i][h][0]][j]) {
                                                
                                                case 1:
                                                     posPoints1 += 6;
                                                     break;
                                                
                                                case 2:
                                                     posPoints1 += 3;
                                                     break;
                                                
                                                case 3:
                                                     posPoints1 += 4;
                                                     break;
                                                
                                                case 4:
                                                     posPoints1 += 5;
                                                     break;
                                                
                                                case 5:
                                                     posPoints1 += 6;
                                                     break;
                                                
                                                case 6:
                                                     switch(houses[i][j-3]) {
                                                           
                                                            case 2:
                                                                 posPoints2 -= 2;
                                                                 break;
                                                            
                                                            case 3:
                                                                 posPoints2 -= 3;
                                                                 break;
                                                            
                                                            case 4:
                                                                 posPoints2 -= 4;
                                                                 break;
                                                            
                                                            case 5:
                                                                 posPoints2 -= 5;
                                                                 break;
                                                            
                                                            case 6:
                                                                 posPoints2 -= 6;
                                                                 break;
                                                            
                                                            case 7:
                                                                 posPoints2 -= 7;
                                                                 break;
                                                            
                                                            case 8:
                                                                 posPoints2 -= 6;
                                                                 break;
                                                            
                                                            case 9:
                                                                 posPoints2 -= 5;
                                                                 break;
                                                            
                                                            case 10:
                                                                 posPoints2 -= 4;
                                                                 break;
                                                            
                                                            case 11:
                                                                 posPoints2 -= 3;
                                                                 break;
                                                            
                                                            case 12:
                                                                 posPoints2 -= 2;
                                                                 break;
                                                     }
                                                     break;
                                          }
                                      }
                                      for (int j = 0; j < 3; j++) {
                                          switch(houses[buildCheck[i][h][0]][j]) {
                                                
                                                case 2:
                                                     posPoints2 += 2;
                                                     break;
                                                
                                                case 3:
                                                     posPoints2 += 3;
                                                     break;
                                                
                                                case 4:
                                                     posPoints2 += 4;
                                                     break;
                                                
                                                case 5:
                                                     posPoints2 += 5;
                                                     break;
                                                
                                                case 6:
                                                     posPoints2 += 6;
                                                     break;
                                                
                                                case 7:
                                                     posPoints2 += 7;
                                                     break;
                                                
                                                case 8:
                                                     posPoints2 += 6;
                                                     break;
                                                
                                                case 9:
                                                     posPoints2 += 5;
                                                     break;
                                                
                                                case 10:
                                                     posPoints2 += 4;
                                                     break;
                                                
                                                case 11:
                                                     posPoints2 += 3;
                                                     break;
                                                
                                                case 12:
                                                     posPoints2 += 2;
                                                     break;
                                          }
                                      }
                                      if (buildCheck[i][h][3] < 0) {
                                         posPoints = (posPoints1 * posPoints2) * 2;
                                      } else {
                                         posPoints = posPoints1 * posPoints2;
                                      }
                                      if (player3too1[player] == false && (buildCheck[i][h][0] == 0 || buildCheck[i][h][0] == 1 || buildCheck[i][h][0] == 14 || buildCheck[i][h][0] == 15 || buildCheck[i][h][0] == 26 || buildCheck[i][h][0] == 37 || buildCheck[i][h][0] == 47 || buildCheck[i][h][0] == 48)) {
                                         posPoints += 300;
                                      } else if (buildCheck[i][h][0] == 3 || buildCheck[i][h][0] == 4 || buildCheck[i][h][0] == 45 || buildCheck[i][h][0] == 46 || buildCheck[i][h][0] == 50 || buildCheck[i][h][0] == 51 || buildCheck[i][h][0] == 28 || buildCheck[i][h][0] == 38 || buildCheck[i][h][0] == 7 || buildCheck[i][h][0] == 17) {
                                         posPoints += 150;
                                      }
                                      if (posPoints > posPointsTop) {
                                         posPointsTop = posPoints;
                                         if (streets[buildCheck[i][h][1]] == 0) {
                                            picked = 200 + buildCheck[i][h][1];
                                            lButtonOneTime = false;
                                            buildHouse[player][0] = true;
                                         } else if (streets[buildCheck[i][h][2]] == 0) {
                                            picked = 200 + buildCheck[i][h][2];
                                            lButtonOneTime = false;
                                            buildHouse[player][0] = true;
                                         } else if (buildCheck[i][h][3] >= 0 && streets[buildCheck[i][h][3]] == 0) {
                                            picked = 200 + buildCheck[i][h][3];
                                            lButtonOneTime = false;
                                            buildHouse[player][0] = true;
                                         } else {
                                            houseBuild = buildCheck[i][h][0];
                                            buildHouse[player][0] = false;
                                            buildHouse[player][1] = true;
                                            lButtonOneTime = true;
                                         }
                                      }
                                      posPoints1 = 0;
                                      posPoints2 = 0;
                                  }
                              }
                          }
                      }
                      posPointsTop = 0;
                      kiTurn = 5;
                      kiTime = time;
                   }
                   break;
              
              case 7:
                   if (time >= (kiTime + kiWait1)) {
                      if (houses[houseBuild][6] == 0) {
                         picked = 100 + houseBuild;
                         lButtonOneTime = false;
                         buildHouse[player][0] = true;
                         buildHouse[player][1] = false;
                         buildHouse[player][2] = true;
                         player3too1[0] = false;
                         if (player3too1[0] == false && (houseBuild == 0 || houseBuild == 1 || houseBuild == 14 || houseBuild == 15 || houseBuild == 26 || houseBuild == 37 || houseBuild == 47 || houseBuild == 48)) {
                            player3too1[0] = true;
                         }
                      } else {
                         buildHouse[player][0] = true;
                         buildHouse[player][1] = false;
                      }
                      if (player3too1[0] == true) {
                         player3too1[0] = false;
                         player3too1[player] = true;
                      }
                      kiTurn = 5;
                      kiTime = time;
                   }
                   break;
              
              case 8:
                   if (time >= (kiTime + kiWait1)) {
                      for (int i = 0; i < 54; i++) {
                          if (houses[i][7] == player && houses[i][6] == 1) {
                             for (int j = 3; j < 6; j++) {
                                  switch(houses[i][j]) {
                                        
                                        case 1:
                                             posPoints1 += 6;
                                             break;
                                        
                                        case 2:
                                             posPoints1 += 3;
                                             break;
                                        
                                        case 3:
                                             posPoints1 += 4;
                                             break;
                                        
                                        case 4:
                                             posPoints1 += 5;
                                             break;
                                        
                                        case 5:
                                             posPoints1 += 6;
                                             break;
                                        
                                        case 6:
                                             switch(houses[i][j-3]) {
                                                   
                                                    case 2:
                                                         posPoints2 -= 2;
                                                         break;
                                                    
                                                    case 3:
                                                         posPoints2 -= 3;
                                                         break;
                                                    
                                                    case 4:
                                                         posPoints2 -= 4;
                                                         break;
                                                    
                                                    case 5:
                                                         posPoints2 -= 5;
                                                         break;
                                                    
                                                    case 6:
                                                         posPoints2 -= 6;
                                                         break;
                                                    
                                                    case 7:
                                                         posPoints2 -= 7;
                                                         break;
                                                    
                                                    case 8:
                                                         posPoints2 -= 6;
                                                         break;
                                                    
                                                    case 9:
                                                         posPoints2 -= 5;
                                                         break;
                                                    
                                                    case 10:
                                                         posPoints2 -= 4;
                                                         break;
                                                    
                                                    case 11:
                                                         posPoints2 -= 3;
                                                         break;
                                                    
                                                    case 12:
                                                         posPoints2 -= 2;
                                                         break;
                                             }
                                             break;
                                  }
                              }
                              for (int j = 0; j < 3; j++) {
                                  switch(houses[i][j]) {
                                        
                                        case 2:
                                             posPoints2 += 2;
                                             break;
                                        
                                        case 3:
                                             posPoints2 += 3;
                                             break;
                                        
                                        case 4:
                                             posPoints2 += 4;
                                             break;
                                        
                                        case 5:
                                             posPoints2 += 5;
                                             break;
                                        
                                        case 6:
                                             posPoints2 += 6;
                                             break;
                                        
                                        case 7:
                                             posPoints2 += 7;
                                             break;
                                        
                                        case 8:
                                             posPoints2 += 6;
                                             break;
                                        
                                        case 9:
                                             posPoints2 += 5;
                                             break;
                                        
                                        case 10:
                                             posPoints2 += 4;
                                             break;
                                        
                                        case 11:
                                             posPoints2 += 3;
                                             break;
                                        
                                        case 12:
                                             posPoints2 += 2;
                                             break;
                                  }
                              }
                              posPoints = posPoints1 * posPoints2;
                              if (posPoints > posPointsTop) {
                                 posPointsTop = posPoints;
                                 picked = 100 + i;
                                 lButtonOneTime = false;
                                 buildHouse[player][2] = true;
                              }
                              posPoints1 = 0;
                              posPoints2 = 0;
                          }
                      }
                      posPointsTop = 0;
                      kiTurn = 5;
                      kiTime = time;
                   }
                   break;
              
              case 9:
                   if (time >= (kiTime + kiWait1)) {
                       picked = 311;
                       next = true;
                       kiTurn++;
                       lButtonOneTime = false;
                   }
                   break;
              
              case 10:
                   kiTurn = 0;
                   lButtonDown = false;
                   lButtonOneTime = false;
                   break;
          }
       }
    }
    
    if (playerCheck == true) {
       playerCheck = false;
       if (player < playersPicked) {
         player++;
       } else {
         player = 1;
       }
       if (playerKI[player] == true) {
         kiTurn = 1;
       }
       //pointerV[19] = playerV[player-1];
       if (firstTime == (playersPicked * 4)) {
          build = false;
          redraw = true;
          buildFT = false;
          firstTime++;
          if (playerKI[player] == false) {
            wuerfeln = true;
          }
       }
    }
    
    if (redraw == true) {
       redraw = false;
       
       for (int i = 0; i < 54; i++) {
           housesV[i] = deleteObj;
       }
       for (int i = 0; i < 72; i++) {
           streetsV[i] = deleteObj;
       }       
       for (int i = 0; i < 54; i++) {
                  switch(houses[i][6]) {
                        
                        case 1:
                             switch(houses[i][7]) {
                                    case 1:
                                         housesV[i] = object1;
                                         break;
                                         
                                    case 2:
                                         housesV[i] = object2;
                                         break;
                                    
                                    case 3:
                                         housesV[i] = object3;
                                         break;
                                         
                                    case 4:
                                         housesV[i] = object4;
                                         break;
                             }
                             break;
                        
                        case 2:
                             switch(houses[i][7]) {
                                    case 1:
                                         housesV[i] = object5;
                                         break;
                                         
                                    case 2:
                                         housesV[i] = object6;
                                         break;
                                    
                                    case 3:
                                         housesV[i] = object7;
                                         break;
                                         
                                    case 4:
                                         housesV[i] = object8;
                                         break;
                             }
                             break;
                  }
       }
       for (int i = 0; i < 72; i++) {
                  switch(streets[i]) {                        
                        case 1:
                             streetsV[i] = object9;
                             break;
                        
                        case 2:
                             streetsV[i] = object10;
                             break;
                        
                        case 3:
                             streetsV[i] = object11;
                             break;
                        
                        case 4:
                             streetsV[i] = object12;
                             break;
                  }
       }
    }
    
    if (buildFT == true) {
       buildFT = false;
       
       for(int i = 0; i < 54; i++) {
           switch(houses[i][6]) {
           
                 case 0:
                      if (houses[availableCheck1[i][0]][6] == 0 && houses[availableCheck1[i][1]][6] == 0 && (availableCheck1[i][2] < 0 || houses[availableCheck1[i][2]][6] == 0)) {
                            if (firstTime < (playersPicked * 4)) {
                               if ((firstTime % 2) == 0) {
                                  housesV[i] = buildV[player][1];
                               }  
                            } else if ((streets[availableCheck1[i][3]] == player || streets[availableCheck1[i][4]] == player || (availableCheck1[i][5] >= 0 && streets[availableCheck1[i][5]] == player)) && resources[player][1] >= 1 && resources[player][2] >= 1 && resources[player][3] >= 1 && resources[player][5] >= 1) {
                                  housesV[i] = buildV[player][1];
                            }
                      }
                      break;
                 
                 case 1:
                      if (houses[i][7] == player && resources[player][3] >=2 && resources[player][4] >= 3) {
                            housesV[i] = buildV[player][2];
                      }
                      break;
           }
       }
       for(int i = 0; i < 72; i++) {
           if (streets[i] == 0) {
                 if (firstTime < (playersPicked * 4) && ((houses[availableCheck2[i][0]][7] == player && (availableCheck2[i][2] < 0 || streets[availableCheck2[i][2]] == 0) && (availableCheck2[i][3] < 0 || streets[availableCheck2[i][3]] == 0)) || (houses[availableCheck2[i][1]][7] == player && (availableCheck2[i][4] < 0 || streets[availableCheck2[i][4]] == 0) && (availableCheck2[i][5] < 0 || streets[availableCheck2[i][5]] == 0)))) {
                    if ((firstTime % 2) == 1) {
                       streetsV[i] = buildV[player][0];
                    }
                 } else if ((houses[availableCheck2[i][0]][7] == player || houses[availableCheck2[i][1]][7] == player || (availableCheck2[i][2] >= 0 && streets[availableCheck2[i][2]] == player) || (availableCheck2[i][3] >= 0 && streets[availableCheck2[i][3]] == player) || (availableCheck2[i][4] >= 0 && streets[availableCheck2[i][4]] == player) || (availableCheck2[i][5] >= 0 && streets[availableCheck2[i][5]] == player)) && resources[player][1] >= 1 && resources[player][5] >= 1) {
                       streetsV[i] = buildV[player][0];
                 }
           }
       }
    }
    
    glutPostRedisplay();
}

static void 
display(void)
{    
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    draw(GL_RENDER);
    
    glFlush();
    glutSwapBuffers();    
}

int 
main(int argc, char *argv[])
{
    /**glutInit(&argc, argv);
    glutInitWindowSize(640,480);
    glutInitWindowPosition(10,10);
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
    glutCreateWindow("DBVD");*/
    
    glutInit( &argc, argv );
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);		
    switch(resolution) {
           
           case 1:
                glutGameModeString("800x600:32@100");
                if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                    font = (int)GLUT_BITMAP_HELVETICA_12;
                    glutEnterGameMode();
                } else {
                    glutGameModeString("800x600:32@85");
                    if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                       font = (int)GLUT_BITMAP_HELVETICA_12;
                       glutEnterGameMode();
                    } else {
                       glutGameModeString("800x600:32@60");
                       if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                          font = (int)GLUT_BITMAP_HELVETICA_12;
                          glutEnterGameMode();
                       } else {
                          exit(0);
                       }
                    }
                }
                break;
           
           case 2:
                glutGameModeString("1024x768:32@100");
                if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                    font = (int)GLUT_BITMAP_HELVETICA_18;
                    glutEnterGameMode();
                } else {
                    glutGameModeString("1024x768:32@85");
                    if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                       font = (int)GLUT_BITMAP_HELVETICA_18;
                       glutEnterGameMode();
                    } else {
                       glutGameModeString("1024x768:32@60");
                       if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                          font = (int)GLUT_BITMAP_HELVETICA_18;
                          glutEnterGameMode();
                       } else {
                          exit(0);
                       }
                    }
                }
                break;
           
           case 3:
                glutGameModeString("1280x1024:32@100");
                if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                    glutEnterGameMode();
                } else {
                    glutGameModeString("1280x1024:32@85");
                    if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                       glutEnterGameMode();
                    } else {
                       glutGameModeString("1280x1024:32@60");
                       if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                          glutEnterGameMode();
                       } else {
                          exit(0);
                       }
                    }
                }
                break;
           
           case 4:
                glutGameModeString("1600x1200:32@100");
                if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                    glutEnterGameMode();
                } else {
                    glutGameModeString("1600x1200:32@85");
                    if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                       glutEnterGameMode();
                    } else {
                       glutGameModeString("1600x1200:32@60");
                       if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                          glutEnterGameMode();
                       } else {
                          exit(0);
                       }
                    }
                }
                break;
           
           default:
                    glutGameModeString("1600x1200:32@100");
                    if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                        glutEnterGameMode();
                    } else {
                        glutGameModeString("1600x1200:32@85");
                        if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                           glutEnterGameMode();
                        } else {
                           glutGameModeString("1600x1200:32@60");
                           if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                              glutEnterGameMode();
                           } else {
                                glutGameModeString("1280x1024:32@100");
                                if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                    glutEnterGameMode();
                                } else {
                                    glutGameModeString("1280x1024:32@85");
                                    if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                       glutEnterGameMode();
                                    } else {
                                       glutGameModeString("1280x1024:32@60");
                                       if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                          glutEnterGameMode();
                                       } else {
                                            glutGameModeString("1024x768:32@100");
                                            if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                                font = (int)GLUT_BITMAP_HELVETICA_18;
                                                glutEnterGameMode();
                                            } else {
                                                glutGameModeString("1024x768:32@85");
                                                if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                                   font = (int)GLUT_BITMAP_HELVETICA_18;
                                                   glutEnterGameMode();
                                                } else {
                                                   glutGameModeString("1024x768:32@60");
                                                   if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                                      font = (int)GLUT_BITMAP_HELVETICA_18;
                                                      glutEnterGameMode();
                                                   } else {
                                                        glutGameModeString("800x600:32@100");
                                                        if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                                            font = (int)GLUT_BITMAP_HELVETICA_12;
                                                            glutEnterGameMode();
                                                        } else {
                                                            glutGameModeString("800x600:32@85");
                                                            if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                                               font = (int)GLUT_BITMAP_HELVETICA_12;
                                                               glutEnterGameMode();
                                                            } else {
                                                               glutGameModeString("800x600:32@60");
                                                               if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
                                                                  font = (int)GLUT_BITMAP_HELVETICA_12;
                                                                  glutEnterGameMode();
                                                               } else {
                                                                  exit(0);
                                                               }
                                                            }
                                                        }
                                                   }
                                                }
                                            }
                                       }
                                    }
                                }
                           }
                        }
                    }
                   break;
    }
        
    
    
    init();    
    glutMouseFunc(mouse);
    glutReshapeFunc(resize);
    glutDisplayFunc(display);    
    glutMotionFunc(mouseMotion);
    glutSpecialFunc(key2);    
    glutKeyboardFunc(key);
    glutIdleFunc(idle);    

    glutMainLoop();
    return EXIT_SUCCESS;
}
